#ifndef _CRI_FSEL_H_INCLUDED		/* Re-definition prevention */
#define _CRI_FSEL_H_INCLUDED
/*******************************************************************/
/*                                                                 */
/*          File Select Library (for Dreamcast)                    */
/*                                                                 */
/*              written by M.Oshimi         1999.2.9               */
/*                                                                 */
/*******************************************************************/
#define		FSEL_VER		"2.00"		/*	Version number	*/

/*******************************************************************
 *      Data type declaration
 *******************************************************************/
/* ֐e[u\ */
typedef struct _fsel_ftbl {
	void		(*BeginDraw)(void);
	void		(*EndDraw)(void);
	void		(*WaitVBlank)(void);
	long		(*Printf)(long lx, long ly, char *fmt,...);
	Sint32		(*SetColor)(long color);
	void		(*GetMetrix)(long *w, long *h);
} FSEL_FTBL;

/*******************************************************************
 *      External Function declaration
 *******************************************************************/
extern FSEL_FTBL fsel_ftbl_usr;

/*******************************************************************
 *      Function macro
 *******************************************************************/
#define FSEL_Select(next, ext) \
			FSEL_SelectEx(next, ext, &fsel_ftbl_usr)
#define FSEL_Init(dir, ext) \
			FSEL_InitEx(dir, ext, &fsel_ftbl_usr)

/*******************************************************************
 *      Function declaration
 *******************************************************************/
/*	t@CZN^̏ 	*/
void FSEL_InitEx(void *dir, char *ext, FSEL_FTBL *ftbl);
/*	t@CI	*/
char *FSEL_SelectFile(void);
/*	t@CIiAj	*/
char *FSEL_SelectEx(long next, char *ext[], FSEL_FTBL *ftbl);

#endif							/* Re-definition prevention */

/* end of file */
