/*
 *  Middleware Library
 *  Copyright (c) 1998 SEGA
 *  
 *		Dual Speech
 *
 *  Module  : Library Header File
 *  File    : DLSE_MW.H
 *  Create  : 1999-06-16
 *  Modify  : 1999-09-21
 *  Note    :
 */

#ifndef	_DLSE_MW_H_
#define	_DLSE_MW_H_

/***************************************************************************
 *      Process MACRO
 ***************************************************************************/
#define	MWD_DLSE_CALC_WORK(n)		(28 * n)

#define	MWD_DLSE_EXTRA_SIZE			(640)

#define	MWD_DLSE_MEMORY_LIMIT		(20)

#ifdef	__cplusplus
extern	"C"	{
#endif	/*	__cplusplus		*/

/***************************************************************************
 *		Variable Declaration
 ***************************************************************************/
extern	ECAIF	mwg_ecaif_dlse;

/***************************************************************************
 *      Function Declaration
 ***************************************************************************/
/*	Initialize Dual Speech Encoder Library		*/
#define	mwRecInitDlse(mode)			mwRcaInit(mode, &mwg_ecaif_dlse)

/*	Finish using Dual Speech Encoder Library	*/
#define	mwRecFinishDlse()			mwRcaFinish(&mwg_ecaif_dlse)

/*	Create MWREC handle for Dual Speech Encoder	*/
#define	mwRecCreateDlse(cprm)		mwRcaCreate(cprm, &mwg_ecaif_dlse)

#ifdef	__cplusplus
}
#endif	/*	__cplusplus		*/
#endif	/*	_DLSE_MW_H_	*/
