/*
 *  Middleware Library
 *  Copyright (c) 1998 SEGA
 *  
 *		Middleware Play
 *
 *  Module  : Library Header File
 *  File    : sg_symng.h
 *  Create  : 2000-03-22
 *  Modify  :
 *  Note    :
 */

#ifndef _SYMNG_H_
#define _SYMNG_H_

/*	Version No.	*/
#define		SYD_MNG_VER		"1.03"

/***********************************************************************
 *      CN[ht@C
 ***********************************************************************/
#include <sg_xpt.h>

/***********************************************************************
 *      萔}N
 ***********************************************************************/

/*	t@Cox	*/
#define	SYD_MNG_FLVL_TMR			(0)
#define	SYD_MNG_FLVL_UHIGH			(1)
#define	SYD_MNG_FLVL_MAIN			(2)
#define	SYD_MNG_FLVL_MW				(3)
#define	SYD_MNG_FLVL_UIDL			(4)

/***********************************************************************
 *      񋓒萔
 ***********************************************************************/

/***********************************************************************
 *      }N
 ***********************************************************************/

/***********************************************************************
 *      f[^^̐錾
 ***********************************************************************/
/*	R[obN֐\				*/
typedef	struct	{
	Bool	(*func)(void *obj);				/*	R[obN֐			*/
	void	*obj;							/*							*/
}	SYS_CBFN;

/*	G[R[obN֐\				*/
typedef	struct	{
	void	(*func)(void *obj, char *str);	/*	R[obN֐			*/
	void	*obj;							/*							*/
}	SYS_CBFN_ERR;

/***********************************************************************
 *		ϐ̐錾
 ***********************************************************************/

/***********************************************************************
 *      ֐̐錾
 ***********************************************************************/

#ifdef __cplusplus
extern "C" {
#endif

/*	G[֐̓o^								*/
void syMngEntryErrFn(void (*errfn)(void *obj, char *emsg), void *obj);

/*	G[֐̋N (ʂ̊֐̌Ăяoj		*/
void syMngError(char *fmt,...);

/*	V-Sync҂R[obN֐̓o^	*/
void syMngEntryWaitVsyncCallback(void (*func)(void *obj), void *obj);

/*	`lQDMAIɃCt@Co֖߂邩ۂ@(for only Middleware)	*/
void syMngSetCh2DmaMwFlag(Sint32 sw);

/*	YUVf[^]IɃCt@Co֖߂邩ۂ@(for only Middleware)	*/
void syMngSetEotYuvMwFlag(Sint32 sw);

/*	t@Conh̎擾	*/
SYFBR syMngGetFbr(Sint32 flvl);

/***
*		Tut@Co֐
***/

/*	Tut@Co֐̓o^								*/
void syMngEntrySfbrFunc(Sint32 flvl, Bool (*func)(void *obj), void *obj);

/*	Tut@Co֐̍폜								*/
void syMngDeleteSfbrFunc(Sint32 flvl, Bool (*func)(void *obj));

/*	t@Co֐̃N[Abv	*/
void syMngCleanUpSfbrFunc(Sint32 flvl);

/***
*		t@CoRg[
***/

/*	KamuiWaitVsyncCallbackgp邩ۂ	*/
void syMngConfigUsingKmWaitVsyncCb(Sint32 flag);

/*	^C}t@Co̎sԂ̐ݒ	*/
void syMngSetTmrDur(Float time);

/*	gbvxt@Co̐ݒ	*/
void syMngSetSfbrTopLvl(Sint32 flvl);

/*	Jgt@Cox̎擾	*/
Sint32 syMngGetCurFlvl(void);

/*	Tut@Coւ̃XCb`	*/
Sint32 syMngSwitch(Sint32 flvl);

/*	荞ݓTut@Coւ̃XCb`	*/
Sint32 syMngDelayedSwitch(Sint32 flvl);

/*	t@Coւ̃XCb`	*/
void syMngSleep(void);

/***
*			EI
***/

/*		*/
void syMngInit(void);
/*	I	*/
void syMngFinish(void);

#ifdef __cplusplus
}
#endif

#endif
