/*++

  COPYRIGHT        (C) NEC        Corporation 1997 - 1999

  All rights reserved by NEC Corporation. This program must be
  used solely for the purpose for which it was furnished by NEC
  Corporation. No part of this program may be reproduced or
  disclosed to others, in any form, without the prior written
  permission of NEC Corporation.
  Use of copyright notice does not evidence publication of this
  program.

  Author     :		T.Kamei(NEC Software,Ltd.)
  Module Name:		km2vtxapi.h

  Abstract:
	KAMUI = Kamui is abstruction model that is ultimate interface for PowerVR.
	'km2vtxapi.h' define the function which manage vertex strip ,generate strip head ,
	process vertex context and is related with vertex strip.

  Environment:
	ANSI C Compiler.

  Notes:

  Revision History:

--*/

#if !defined(__kamui2_vertex_api_h__)
#define __kamui2_vertex_api_h__
/*++
kmGenerateStripHead

proto type:
	KMSTATUS KMAPI
	kmGenerateStripHead(
	        OUT PKMSTRIPHEAD        pStripHead,
	        IN  PKMSTRIPCONTEXT     pStripContext,
			IN  KMVERTEXTYPE		nVertexType
		);

Description:
	pStripContext ̓eɁAnVertexType Ŏw肳ꂽ_^CvɂA
	KMSTRIPHEAD 쐬 pStripHead ̈ɏ݂܂B

	̂́A kmGenerateStripHeadxx() ւ̃fBXpb`łB
	gp钸_^Cv܂ĂꍇɂkmGenerateStripHeadxx()
	gpق኱ł(xx : 00 - 17 ̔Cӂ̐l)B

Arguments:
	OUT pStripHead		 KMSTRIPHEADޗ̈
						|C^łB

	IN  pStripContext	StripHead 𐶐邽߂̌ɂȂi[
						KMSTRIPCONTEXT \̂ւ̃|C^w肵܂B

	IN  nVertexType		gp钸_̎ނɂāApStripHead ɏޓeقȂ邽߁A
						KMSTRIPCONTEXT gpĐ KMSTRIPHEAĎɑ
						_̃^Cvw肵܂B

Result:
	KMSTATUS_SUCCESS		

--*/
KMSTATUS KMAPI
kmGenerateStripHead(
        OUT PKMSTRIPHEAD        pStripHead,
        IN  PKMSTRIPCONTEXT     pStripContext,
		IN  KMVERTEXTYPE		nVertexType
	);

/*++
kmGenerateStripHeadxx

proto type:
	KMSTATUS KMAPI
	kmGenerateStripHeadxx(
	        OUT PKMSTRIPHEAD        pStripHead,
	        IN  PKMSTRIPCONTEXT     pStripContext
		);

Description:
	xx  00 - 17 ̔Cӂ̐lŒ_^Cv܂B
	钸_^Cvɓ KMSTRIPHEAD ֐QłB

	e֐ pStripContext ̓e xx  _^Cvɂ
	KMSTRIPHEAD 쐬 pStripHead ̈ɏ݂܂B

Arguments:
	OUT pStripHead		 KMSTRIPHEADޗ̈
						|C^łB

	IN  pStripContext	StripHead 𐶐邽߂̌ɂȂi[
						KMSTRIPCONTEXT \̂ւ̃|C^w肵܂B

Result:
	KMSTATUS_SUCCESS		

--*/

KMSTATUS KMAPI
kmGenerateStripHead00(
        OUT PKMSTRIPHEAD        pStripHead,
        IN  PKMSTRIPCONTEXT     pStripContext
	);

KMSTATUS KMAPI
kmGenerateStripHead01(
        OUT PKMSTRIPHEAD        pStripHead,
        IN  PKMSTRIPCONTEXT     pStripContext
	);

KMSTATUS KMAPI
kmGenerateStripHead02(
        OUT PKMSTRIPHEAD        pStripHead,
        IN  PKMSTRIPCONTEXT     pStripContext
	);

KMSTATUS KMAPI
kmGenerateStripHead03(
        OUT PKMSTRIPHEAD        pStripHead,
        IN  PKMSTRIPCONTEXT     pStripContext
	);

KMSTATUS KMAPI
kmGenerateStripHead04(
        OUT PKMSTRIPHEAD        pStripHead,
        IN  PKMSTRIPCONTEXT     pStripContext
	);

KMSTATUS KMAPI
kmGenerateStripHead05(
        OUT PKMSTRIPHEAD        pStripHead,
        IN  PKMSTRIPCONTEXT     pStripContext
	);

KMSTATUS KMAPI
kmGenerateStripHead06(
        OUT PKMSTRIPHEAD        pStripHead,
        IN  PKMSTRIPCONTEXT     pStripContext
	);

KMSTATUS KMAPI
kmGenerateStripHead07(
        OUT PKMSTRIPHEAD        pStripHead,
        IN  PKMSTRIPCONTEXT     pStripContext
	);

KMSTATUS KMAPI
kmGenerateStripHead08(
        OUT PKMSTRIPHEAD        pStripHead,
        IN  PKMSTRIPCONTEXT     pStripContext
	);

KMSTATUS KMAPI
kmGenerateStripHead09(
        OUT PKMSTRIPHEAD        pStripHead,
        IN  PKMSTRIPCONTEXT     pStripContext
	);

KMSTATUS KMAPI
kmGenerateStripHead10(
        OUT PKMSTRIPHEAD        pStripHead,
        IN  PKMSTRIPCONTEXT     pStripContext
	);

KMSTATUS KMAPI
kmGenerateStripHead11(
        OUT PKMSTRIPHEAD        pStripHead,
        IN  PKMSTRIPCONTEXT     pStripContext
	);

KMSTATUS KMAPI
kmGenerateStripHead12(
        OUT PKMSTRIPHEAD        pStripHead,
        IN  PKMSTRIPCONTEXT     pStripContext
	);

KMSTATUS KMAPI
kmGenerateStripHead13(
        OUT PKMSTRIPHEAD        pStripHead,
        IN  PKMSTRIPCONTEXT     pStripContext
	);

KMSTATUS KMAPI
kmGenerateStripHead14(
        OUT PKMSTRIPHEAD        pStripHead,
        IN  PKMSTRIPCONTEXT     pStripContext
	);

KMSTATUS KMAPI
kmGenerateStripHead15(
        OUT PKMSTRIPHEAD        pStripHead,
        IN  PKMSTRIPCONTEXT     pStripContext
	);

KMSTATUS KMAPI
kmGenerateStripHead16(
        OUT PKMSTRIPHEAD        pStripHead,
        IN  PKMSTRIPCONTEXT     pStripContext
	);

KMSTATUS KMAPI
kmGenerateStripHead17(
        OUT PKMSTRIPHEAD        pStripHead,
        IN  PKMSTRIPCONTEXT     pStripContext
	);

/*++
kmInitStripContext

proto type:
	KMSTATUS KMAPI
	kmInitStripContext(
			IN  KMDWORD		dwIndex,
			OUT PKMVOID		pStripContext
		);

Description:
	T^I KMSTRIPCONTEXT 𐶐ApStripContexẗ
	݂܂B

Arguments:
	IN  dwIndex			Index łB
	OUT pStripContext	󂯎̈ւ̃|C^łB

Result:
	KMSTATUS_SUCCESS		

--*/
KMSTATUS KMAPI
kmInitStripContext(
		IN  KMDWORD		dwIndex,
		OUT PKMVOID		pStripContext
	);

/*++
kmRegisterStripContext

proto type:
	KMSTATUS KMAPI
	kmRegisterStripContext(
			IN  KMDWORD				dwIndex,
			IN  PKMSTRIPCONTEXT     pStripContext
		);

Description:
	悭gp邨Cɓ STRIPCONTEXT \̂
	Ŏgp邽߂ɃVXeɈUo^Ă֐łB

Arguments:
	IN  dwIndex				̈ index
	IN  pStripContext		

Result:
	KMSTATUS_SUCCESS		

--*/
KMSTATUS KMAPI
kmRegisterStripContext(
		IN  KMDWORD				dwIndex,
		IN  PKMSTRIPCONTEXT     pStripContext
	);

/*++
kmStartStrip

proto type:
	KMSTATUS KMAPI
	kmStartStrip(
			IN  PKMVERTEXBUFFDESC   pVertexBuffDesc,
			IN  PKMSTRIPHEAD        pStripHead
		);

Description:

Arguments:
	IN  pVertexBuffDesc		f[^o^钸_f[^Xg̏A
							PKMVERTEXBUFFDESC^́AVertex Buffer Descriptorւ
							|C^łB

	IN  pStripHead			_Xg̐擪ɂȂ KMSTRIPHEAD \̂ւ
							|C^łB

Result:
	KMSTATUS_SUCCESS		

--*/
#if !defined(_KM_USE_VERTEX_MACRO_)
KMSTATUS KMAPI
kmStartStrip(
		IN  PKMVERTEXBUFFDESC   pVertexBuffDesc,
		IN  PKMSTRIPHEAD        pStripHead
	);
#endif


/*++
kmEndStrip

proto type:

Description:

Arguments:
	IN  pVertexBuffDesc		f[^o^钸_f[^Xg̏A
							PKMVERTEXBUFFDESC^́AVertex Buffer Descriptorւ
							|C^łB

Result:
	KMSTATUS_SUCCESS		

--*/
KMSTATUS KMAPI
kmEndStrip(
		IN  PKMVERTEXBUFFDESC   pVertexBuffDesc
	);

/*++
kmSetVertex

proto type:
	KMSTATUS
	kmSetVertex(
			PKMVERTEXBUFFDESC pBufferDesc,
			PVOID pVertex,
			KMVERTEXTYPE VertexType,
			KMINT32 StructSize
		);

Description:
	pVertexw_f[^AVXeɓo^ς݂̃_p[^ ListType Ŏw肵_f[^Xg֏݂܂B
	Xgbv̍ŌƂȂ钸_f[^Parameter Control Word KM_VERTEXPARAM_ENDOFSTRIP łȂƂ͕̓ۏ؂܂B

	ӁF	ŏޒ_p[^̌`ƁȂOkmSetVertexRenderStateŐݒ肵O[op[^̌`
			gݍ킹Ȃꍇ͕̓ۏ؂܂B

	<{֐͍v邽InlineWJ}NƂĒ`܂B>

	}Ngpꍇɂ́Aȉ̂悤ɐݒ肵ĂB

		#define _KM_USE_VERTEX_MACRO_
		#include <kamui.h>
		#include <kamuix.h> 

Arguments:
	IN	pBufferDesc		PKMVERTEXBUFFDESC^́AVertex Buffer Descriptorւ̃|C^łB
	IN	pVertex			_f[^\̂ւ̃|C^łB
	IN	VertexType		_f[^̃f[^^Cv܂BL̂ꂩw肵܂B
						KM_VERTEXTYPE_00			// _f[^ Type 0
						KM_VERTEXTYPE_01			// _f[^ Type 1
						KM_VERTEXTYPE_02			// _f[^ Type 2
						KM_VERTEXTYPE_03			// _f[^ Type 3
						KM_VERTEXTYPE_04			// _f[^ Type 4
						KM_VERTEXTYPE_05			// _f[^ Type 5
						KM_VERTEXTYPE_06			// _f[^ Type 6
						KM_VERTEXTYPE_07			// _f[^ Type 7
						KM_VERTEXTYPE_08			// _f[^ Type 8
						KM_VERTEXTYPE_09			// _f[^ Type 9
						KM_VERTEXTYPE_10			// _f[^ Type 10
						KM_VERTEXTYPE_11			// _f[^ Type 11
						KM_VERTEXTYPE_12			// _f[^ Type 12
						KM_VERTEXTYPE_13			// _f[^ Type 13
						KM_VERTEXTYPE_14			// _f[^ Type 14
						KM_VERTEXTYPE_15			// _f[^ Type 15
						KM_VERTEXTYPE_16			// _f[^ Type 16
						KM_VERTEXTYPE_17			// _f[^ Type 17

	IN	StructSize		_f[^̃f[^^CvTCY܂B_f[^Ɏgp^Cvɍ킹āA
						sizeof(KMVERTEX_01)̗lɎw肵ĂB

Result:
	KMSTATUS_SUCCESS			_f[^ݐ
	KMSTATUS_NOT_ENOUGH_MEMORY	_f[^Xg̗eʂȂ

--*/
#if !defined(_KM_USE_VERTEX_MACRO_)
KMSTATUS KMAPI
kmSetVertex(
		IN	PKMVERTEXBUFFDESC pBufferDesc,
		IN	PVOID pVertex,
		IN	KMVERTEXTYPE VertexType,
		IN	KMINT32 StructSize
	);
#endif

/*++
kmSetUserClipping

proto type:
	KMSTATUS KMAPI
	kmSetUserClipping(
			IN  PKMVERTEXBUFFDESC   pVertexBuffDesc,
			IN  KMUSERCLIPMODE      nPrevUserClipMode,
			IN  KMLISTTYPE          nListType,
			IN  PKMRECT             pRect
		);

Description:
	IN  pVertexBuffDesc		f[^o^钸_f[^Xg̏A
							PKMVERTEXBUFFDESC^́AVertex Buffer Descriptorւ
							|C^łB
	IN  nPrevUserClipMode	
	IN  nListType			
	IN  pRect				

Arguments:

Result:
	KMSTATUS_SUCCESS		
--*/
KMSTATUS KMAPI
kmSetUserClipping(
		IN  PKMVERTEXBUFFDESC   pVertexBuffDesc,
		IN  KMUSERCLIPMODE      nPrevUserClipMode,
		IN  KMLISTTYPE          nListType,
		IN  PKMRECT             pRect
	);

/*++
kmSetStripHead

proto type:
	KMSTATUS KMAPI
	kmSetStripHead(
			IN  PKMVERTEXBUFFDESC   pVertexBuffDesc,
			IN  PKMSTRIPHEAD        pStripHead
		);

Description:

Arguments:
	IN  pVertexBuffDesc		f[^o^钸_f[^Xg̏A
							PKMVERTEXBUFFDESC^́AVertex Buffer Descriptorւ
							|C^łB
	IN  pStripHead

Result:
	KMSTATUS_SUCCESS		

--*/
KMSTATUS KMAPI
kmSetStripHead(
		IN  PKMVERTEXBUFFDESC   pVertexBuffDesc,
		IN  PKMSTRIPHEAD        pStripHead
	);

/*++
kmChangeStripXxxx

proto type:
	KMSTATUS KMAPI
	kmChangeStripXxxx(
			IN OUT	PKMSTRIPHEAD	pStripHead,
			IN		KMXXXXXX		xXxx
		);

	KMSTATUS KMAPI
	kmChangeStripXxxx(
			IN OUT	PKMSTRIPHEAD	pStripHead,
			IN		KMINT32			nParam,
			IN		KMBLENDINGMODE	xXxxx
		);

Description:
	kmGenerateStripHead gpĐAKMSTRIPHEAD \̂̓e
	ꕔ֐QłB

Arguments:
	IN OUT	pStripHead	ΏۂƂȂ KMSTRIPHEAD \̂ւ̃|C^
	IN		nParam		2 volume Ɋ֌Wp[^ꍇɂ́A
						ǂ̃p[^̂𖾎KvB
	IN		xXxxx		ύXp[^

Result:
	KMSTATUS_SUCCESS		

--*/
KMSTATUS KMAPI
kmChangeStripListType(
		IN OUT	PKMSTRIPHEAD	pStripHead,
		IN		KMLISTTYPE		nListType
	);
KMSTATUS KMAPI
kmChangeStripUserClipMode(
		IN OUT	PKMSTRIPHEAD	pStripHead,
		IN		KMUSERCLIPMODE	nUserClipMode
	);
KMSTATUS KMAPI
kmChangeStripShadowMode(
		IN OUT	PKMSTRIPHEAD	pStripHead,
		IN		KMSHADOWMODE	nShadowMode
	);
KMSTATUS KMAPI
kmChangeStripIntensityMode(
		IN OUT	PKMSTRIPHEAD	pStripHead,
		IN		KMCOLORTYPE		nIntensityMode
	);
KMSTATUS KMAPI
kmChangeStripOffset(
		IN OUT	PKMSTRIPHEAD	pStripHead,
		IN		KMBOOLEAN		bOffset
	);
KMSTATUS KMAPI
kmChangeStripGouraud(
		IN OUT	PKMSTRIPHEAD	pStripHead,
		IN		KMBOOLEAN		bGouraud
	);
KMSTATUS KMAPI
kmChangeStripDepthCompareMode(
		IN OUT	PKMSTRIPHEAD	pStripHead,
		IN		KMDEPTHMODE		nDepthCompareMode
	);
KMSTATUS KMAPI
kmChangeStripModifierInstruction(
		IN OUT	PKMSTRIPHEAD	pStripHead,
		IN		KMDWORD			dwModifierInstruction
	);
KMSTATUS KMAPI
kmChangeStripCullingMode(
		IN OUT	PKMSTRIPHEAD	pStripHead,
		IN		KMCULLINGMODE	nCullingMode
	);
KMSTATUS KMAPI
kmChangeStripZWriteDisable(
		IN OUT	PKMSTRIPHEAD	pStripHead,
		IN		KMBOOLEAN		bZWriteDisable
	);
KMSTATUS KMAPI
kmChangeStripDCalcControl(
		IN OUT	PKMSTRIPHEAD	pStripHead,
		IN		KMBOOLEAN		bDCalcControl
	);
KMSTATUS KMAPI
kmChangeStripBlendingMode(
		IN OUT	PKMSTRIPHEAD	pStripHead,
		IN		KMINT32			nParam,
		IN		KMBLENDINGMODE	nSRCBlendingMode,
		IN		KMBLENDINGMODE	nDSTBlendingMode
	);
KMSTATUS KMAPI
kmChangeStripSRCSelect(
		IN OUT	PKMSTRIPHEAD	pStripHead,
		IN		KMINT32			nParam,
		IN		KMBOOLEAN		bSRCSelect
	);
KMSTATUS KMAPI
kmChangeStripDSTSelect(
		IN OUT	PKMSTRIPHEAD	pStripHead,
		IN		KMINT32			nParam,
		IN		KMBOOLEAN		bDSTSelect
	);
KMSTATUS KMAPI
kmChangeStripFogMode(
		IN OUT	PKMSTRIPHEAD	pStripHead,
		IN		KMINT32			nParam,
		IN		KMFOGMODE		nFogMode
	);
KMSTATUS KMAPI
kmChangeStripColorClamp(
		IN OUT	PKMSTRIPHEAD	pStripHead,
		IN		KMINT32			nParam,
		IN		KMBOOLEAN		bColorClamp
	);
KMSTATUS KMAPI
kmChangeStripUseAlpha(
		IN OUT	PKMSTRIPHEAD	pStripHead,
		IN		KMINT32			nParam,
		IN		KMBOOLEAN		bUseAlpha
	);
KMSTATUS KMAPI
kmChangeStripIgnoreTextureAlpha(
		IN OUT	PKMSTRIPHEAD	pStripHead,
		IN		KMINT32			nParam,
		IN		KMBOOLEAN		bIgnoreTextureAlpha
	);
KMSTATUS KMAPI
kmChangeStripFlipUV(
		IN OUT	PKMSTRIPHEAD	pStripHead,
		IN		KMINT32			nParam,
		IN		KMFLIPMODE		nFlipUV
	);
KMSTATUS KMAPI
kmChangeStripClampUV(
		IN OUT	PKMSTRIPHEAD	pStripHead,
		IN		KMINT32			nParam,
		IN		KMCLAMPMODE		nClampUV
	);
KMSTATUS KMAPI
kmChangeStripFilterMode(
		IN OUT	PKMSTRIPHEAD	pStripHead,
		IN		KMINT32			nParam,
		IN		KMFILTERMODE	nFilterMode
	);
KMSTATUS KMAPI
kmChangeStripSuperSampleMode(
		IN OUT	PKMSTRIPHEAD	pStripHead,
		IN		KMINT32			nParam,
		IN		KMBOOLEAN		bSuperSampleMode
	);
KMSTATUS KMAPI
kmChangeStripMipmapAdjust(
		IN OUT	PKMSTRIPHEAD	pStripHead,
		IN		KMINT32			nParam,
		IN		KMDWORD			dwMipmapAdjust
	);
KMSTATUS KMAPI
kmChangeStripTextureShadingMode(
		IN OUT	PKMSTRIPHEAD			pStripHead,
		IN		KMINT32					nParam,
		IN		KMTEXTURESHADINGMODE	nTextureShadingMode
	);
KMSTATUS KMAPI
kmChangeStripPaletteBank(
		IN OUT	PKMSTRIPHEAD	pStripHead,
		IN		KMINT32			nParam,
		IN		KMDWORD			dwPaletteBank
	);
KMSTATUS KMAPI
kmChangeStripTextureSurface(
		IN OUT	PKMSTRIPHEAD	pStripHead,
        IN      KMINT32         nParam,
		IN		PKMSURFACEDESC	pTextureSurfaceDesc
	);
KMSTATUS KMAPI
kmChangeStripTextureAddress(
		IN OUT	PKMSTRIPHEAD	pStripHead,
		IN		KMINT32			nParam,
		IN		PKMSURFACEDESC	pTextureSurfaceDesc
	);
KMSTATUS KMAPI
kmChangeStripFaceColor(
		IN OUT	PKMSTRIPHEAD	pStripHead,
		IN		KMINT32			nParam,
		IN		PKMFLOATCOLOR	pFaceColor
	);
KMSTATUS KMAPI
kmChangeStripFaceOffsetColor(
		IN OUT	PKMSTRIPHEAD	pStripHead,
		IN		PKMFLOATCOLOR	pFaceOffsetColor
	);
KMSTATUS KMAPI
kmChangeStripSpriteBaseColor(
		IN OUT	PKMSTRIPHEAD	pStripHead,
		IN		KMPACKEDARGB	dwBaseColor
	);
KMSTATUS KMAPI
kmChangeStripSpriteOffsetColor(
		IN OUT	PKMSTRIPHEAD	pStripHead,
		IN		KMPACKEDARGB	dwOffsetColor
	);

/*++
kmChangeContextXxxxx

proto type:

	KMSTATUS KMAPI
	kmChangeContextXxxx(
			IN OUT	PKMVERTEXBUFFDESC	pVertexBuffDesc,
			IN		KMXXXX				xXxxxx
		);

	KMSTATUS KMAPI
	kmChangeContextXxxxx(
			IN OUT	PKMVERTEXBUFFDESC	pVertexBuffDesc,
			IN		KMINT32				nParam,
			IN		KMXXXX				xXxxxx
		);

Description:
	kmSetStripHead gpāAꎞVXeɓo^A
	KMSTRIPHEAD \̂֐QłB

Arguments:
	IN OUT	pVertexBuffDesc		f[^ύX钸_f[^Xg̏A
								PKMVERTEXBUFFDESC^́AVertex Buffer Descriptorւ
								|C^łB

	IN		nParam				2{[Ɋ֌W֐ł͕KvłB
								0 / 1 ĂB

	IN		xXxxxx				ύXp[^

Result:
	KMSTATUS_SUCCESS		

--*/
KMSTATUS KMAPI
kmChangeContextListType(
		IN OUT	PKMVERTEXBUFFDESC	pVertexBuffDesc,
		IN		KMLISTTYPE			nListType
	);

KMSTATUS KMAPI
kmChangeContextUserClipMode(
		IN OUT	PKMVERTEXBUFFDESC	pVertexBuffDesc,
		IN		KMUSERCLIPMODE		nUserClipMode
	);

KMSTATUS KMAPI
kmChangeContextShadowMode(
		IN OUT	PKMVERTEXBUFFDESC	pVertexBuffDesc,
		IN		KMSHADOWMODE		nShadowMode
	);

KMSTATUS KMAPI
kmChangeContextIntensityMode(
		IN OUT	PKMVERTEXBUFFDESC	pVertexBuffDesc,
		IN		KMCOLORTYPE			nIntensityMode
	);

KMSTATUS KMAPI
kmChangeContextOffset(
		IN OUT	PKMVERTEXBUFFDESC	pVertexBuffDesc,
		IN		KMBOOLEAN			bOffset
	);

KMSTATUS KMAPI
kmChangeContextGouraud(
		IN OUT	PKMVERTEXBUFFDESC	pVertexBuffDesc,
		IN		KMBOOLEAN			bGouraud
	);

KMSTATUS KMAPI
kmChangeContextDepthCompareMode(
		IN OUT	PKMVERTEXBUFFDESC	pVertexBuffDesc,
		IN		KMDEPTHMODE			nDepthCompareMode
	);

KMSTATUS KMAPI
kmChangeContextModifierInstruction(
		IN OUT	PKMVERTEXBUFFDESC	pVertexBuffDesc,
		IN		KMDWORD				dwModifierInstruction
	);

KMSTATUS KMAPI
kmChangeContextCullingMode(
		IN OUT	PKMVERTEXBUFFDESC	pVertexBuffDesc,
		IN		KMCULLINGMODE		nCullingMode
	);

KMSTATUS KMAPI
kmChangeContextZWriteDisable(
		IN OUT	PKMVERTEXBUFFDESC	pVertexBuffDesc,
		IN		KMBOOLEAN			bZWriteDisable
	);

KMSTATUS KMAPI
kmChangeContextDCalcControl(
		IN OUT	PKMVERTEXBUFFDESC	pVertexBuffDesc,
		IN		KMBOOLEAN			bDCalcControl
	);

KMSTATUS KMAPI
kmChangeContextBlendingMode(
		IN OUT	PKMVERTEXBUFFDESC	pVertexBuffDesc,
		IN		KMINT32				nParam,
		IN		KMBLENDINGMODE		nSRCBlendingMode,
		IN		KMBLENDINGMODE		nDSTBlendingMode
	);

KMSTATUS KMAPI
kmChangeContextSRCSelect(
		IN OUT	PKMVERTEXBUFFDESC	pVertexBuffDesc,
		IN		KMINT32				nParam,
		IN		KMBOOLEAN			bSRCSelect
	);

KMSTATUS KMAPI
kmChangeContextDSTSelect(
		IN OUT	PKMVERTEXBUFFDESC	pVertexBuffDesc,
		IN		KMINT32				nParam,
		IN		KMBOOLEAN			bDSTSelect
	);

KMSTATUS KMAPI
kmChangeContextFogMode(
		IN OUT	PKMVERTEXBUFFDESC	pVertexBuffDesc,
		IN		KMINT32				nParam,
		IN		KMFOGMODE			nFogMode
	);

KMSTATUS KMAPI
kmChangeContextColorClamp(
		IN OUT	PKMVERTEXBUFFDESC	pVertexBuffDesc,
		IN		KMINT32				nParam,
		IN		KMBOOLEAN			bColorClamp
	);

KMSTATUS KMAPI
kmChangeContextUseAlpha(
		IN OUT	PKMVERTEXBUFFDESC	pVertexBuffDesc,
		IN		KMINT32				nParam,
		IN		KMBOOLEAN			bUseAlpha
	);

KMSTATUS KMAPI
kmChangeContextIgnoreTextureAlpha(
		IN OUT	PKMVERTEXBUFFDESC	pVertexBuffDesc,
		IN		KMINT32				nParam,
		IN		KMBOOLEAN			bIgnoreTextureAlpha
	);

KMSTATUS KMAPI
kmChangeContextFlipUV(
		IN OUT	PKMVERTEXBUFFDESC	pVertexBuffDesc,
		IN		KMINT32				nParam,
		IN		KMFLIPMODE			nFlipUV
	);

KMSTATUS KMAPI
kmChangeContextClampUV(
		IN OUT	PKMVERTEXBUFFDESC	pVertexBuffDesc,
		IN		KMINT32				nParam,
		IN		KMCLAMPMODE			nClampUV
	);

KMSTATUS KMAPI
kmChangeContextFilterMode(
		IN OUT	PKMVERTEXBUFFDESC	pVertexBuffDesc,
		IN		KMINT32				nParam,
		IN		KMFILTERMODE		nFilterMode
	);

KMSTATUS KMAPI
kmChangeContextSuperSampleMode(
		IN OUT	PKMVERTEXBUFFDESC	pVertexBuffDesc,
		IN		KMINT32				nParam,
		IN		KMBOOLEAN			bSuperSampleMode
	);

KMSTATUS KMAPI
kmChangeContextMipmapAdjust(
		IN OUT	PKMVERTEXBUFFDESC	pVertexBuffDesc,
		IN		KMINT32				nParam,
		IN		KMDWORD				dwMipmapAdjust
	);

KMSTATUS KMAPI
kmChangeContextTextureShadingMode(
		IN OUT	PKMVERTEXBUFFDESC		pVertexBuffDesc,
		IN		KMINT32					nParam,
		IN		KMTEXTURESHADINGMODE	nTextureShadingMode
	);

KMSTATUS KMAPI
kmChangeContextPaletteBank(
		IN OUT	PKMVERTEXBUFFDESC	pVertexBuffDesc,
		IN		KMINT32				nParam,
		IN		KMDWORD				dwPaletteBank
	);

KMSTATUS KMAPI
kmChangeContextTextureSurface(
		IN OUT	PKMVERTEXBUFFDESC	pVertexBuffDesc,
        IN      KMINT32				nParam,
		IN		PKMSURFACEDESC		pTextureSurfaceDesc
	);

KMSTATUS KMAPI
kmChangeContextTextureAddress(
		IN OUT	PKMVERTEXBUFFDESC	pVertexBuffDesc,
		IN		KMINT32				nParam,
		IN		PKMSURFACEDESC		pTextureSurfaceDesc
	);

KMSTATUS KMAPI
kmChangeContextFaceColor(
		IN OUT	PKMVERTEXBUFFDESC	pVertexBuffDesc,
		IN		KMINT32				nParam,
		IN		PKMFLOATCOLOR		pFaceColor
	);

KMSTATUS KMAPI
kmChangeContextFaceOffsetColor(
		IN OUT	PKMVERTEXBUFFDESC	pVertexBuffDesc,
		IN		PKMFLOATCOLOR		pFaceOffsetColor
	);

KMSTATUS KMAPI
kmChangeContextSpriteBaseColor(
		IN OUT	PKMVERTEXBUFFDESC	pVertexBuffDesc,
		IN		KMPACKEDARGB		dwBaseColor
	);

KMSTATUS KMAPI
kmChangeContextSpriteOffsetColor(
		IN OUT	PKMVERTEXBUFFDESC	pVertexBuffDesc,
		IN		KMPACKEDARGB		dwOffsetColor
	);

/*----------------------------------------*/
/* KAMUI1 Legacy API                      */
/* -----------------                      */
/* sorry following functions too slow!!   */
/* and KMVERTEXCONTEXT was huge....       */
/* we only left backward compatibility    */
/*----------------------------------------*/
/*++
kmProcessVertexRenderState

proto type:
	KMSTATUS
	kmProcessVertexRenderState(
				PKMVERTEXCONTEXT pVertexContext
			);

Description:
	_(Xgbv)ƂɗLƂȂ郌_OEp[^ݒ肵܂
	(pVertexContext̐ݒlVXeɓo^邽߂̑Os܂)B

	{֐pVertexContextɐݒ肳ꂽlƂɈȉ̒l𐶐܂B
			Global Parameter
			Combined ISP/TSP
			Instruction Word
			TSP Control Word
			Texture Control Bits

	{֐Lf[^́AKMVERTEXCONTEXT̈ȉɎoɕۑ܂B
			pVertexContext->GLOBALPARAMBUFFER
			pVertexContext->ISPPARAMBUFFER
			pVertexContext->TSPPARAMBUFFER
			pVertexContext->TexturePARAMBUFFER

	{֐ɂAOs pVertexContext ̏Lo_OɎgp
	p[^ƂāAVXeɓo^邽߂ɂ́AkmSetVertexRenderStateĂяoƕKv܂B

	VERTEXCONTEXTŏɎgp鎞ɂ́AVERTEXCONTEXTׂ̂Ẵo̒lw()
	Kv܂B

	F
		pVertexContext->RenderState ɂׂẴtOݒ肵AׂẴp[^`ĂB
		`̃rbgꍇ͕̓ۏ؂܂B

Arguments:
	IN	pVertexContext		ReLXgւ̃|C^ݒ肵܂B

Result:
	KMSTATUS_SUCCESS		ݒ萬
	KMSTATUS_INVALIDSETTING	ĂȂ[hݒ

--*/
KMSTATUS KMAPI
kmProcessVertexRenderState(
		IN	PKMVERTEXCONTEXT pVertexContext
	);

/*++
kmSetVertexRenderState

proto type:

	KMSTATUS
	kmSetVertexRenderState (
        	PKMVERTEXBUFFDESC   pVertexBuffDesc,
			PKMVERTEXCONTEXT 	pVertexContext
		);

Description:
	kmProcessVertexRenderStateŏ pVertexContext ̈ȉ̃oyъ֘Al
	_OɎgpp[^ƂăVXeɓo^܂B

			pVertexContext->GLOBALPARAMBUFFER
			pVertexContext->ISPPARAMBUFFER
			pVertexContext->TSPPARAMBUFFER
			pVertexContext->TexturePARAMBUFFER

	{֐̌ĂяoŐݒ肵p[^ {֐̌ŌĂяo kmStartVertexStrip 
	ȍ~̒_(Strip)o^ŗLƂȂ܂B


Arguments:
	OUT	pVertexBuffDesc		KMVERTEXBUFFDESC \̂ւ̃|C^ݒ肵܂B
	IN	pVertexContext		KMVERTEXCONTEXT \̂ւ̃|C^ݒ肵܂B

Result:
	KMSTATUS_SUCCESS		_Op[^o^

--*/
KMSTATUS KMAPI
kmSetVertexRenderState (
        OUT	PKMVERTEXBUFFDESC   pVertexBuffDesc,
		IN	PKMVERTEXCONTEXT 	pVertexContext
	);

/*++
kmSetModifierRenderState

proto type:
	KMSTATUS
	kmSetModifierRenderState(
        	PKMVERTEXBUFFDESC   pVertexBuffDesc,
			PKMVERTEXCONTEXT 	pVertexContext
		);

Description:
	kmProcessVertexRenderStateŐݒ肵KMVERTEXCONTEXT̈ȉ̃oA
	 Modifier Volume ̉e󂯂 PolygońA2 Ԗڂ̃_Op[^
	ƂăVXeɓo^܂B

				pVertexContext->TSPPARAMBUFFER
				pVertexContext->TexturePARAMBUFFER

	ȍ~ Modifier Volume ̉e󂯂 Polygon ̓o^ł́A{֐Ŏw肵
	KMVERTEXCONTEXT 2 Ԗڂ̃_Op[^ƂĎgp܂B

	KMVERTEXCONTEXT\̂̂ȉ̃o͎QƂ܂(܂)B
	(kmSetVertexRenderStateŐݒ肵lLƂȂ܂)
	// for Global Parameter
	KMPARAMTYPE			ParamType			// Parameter Type
	KMLISTTYPE			ListType			// List Type
	KMSTRIPLENGTH		StripLength			// Strip Length
	KMUSERCLIPMODE		UserClipMode		// UserClip Mode
	KMCOLORTYPE			ColorType			// Color Type
	KMUVFORMAT			UVFormat			// UV format

	// for ISP/TSP Instruction Word
	KMDEPTHMODE			DepthMode;			// DepthModew
	KMCULLINGMODE		CullingMode;		// Culling Mode
	KMSCREENCORDINATION	ScreenCoordination;	// Screen Coordination
	KMSHADINGMODE		ShadingMode;		// Shading Mode
	KMMODIFIER			SelectModifier;		// Modifier Volume Valiant
	KMBOOLEAN			bZWriteDisable;		// Z Write Disable

	// for ModifierInstruction
	KMDWORD				ModifierInstruction;// ModifierInstruction
	KMFLOAT				fBoundingBoxXmin;	// BoundingBoxXmin(ShadowVolume)
	KMFLOAT				fBoundingBoxYmin;	// BoundingBoxYmin(ShadowVolume)
	KMFLOAT				fBoundingBoxXmax;	// BoundingBoxXmax(ShadowVolume)
	KMFLOAT				fBoundingBoxYmax;	// BoundingBoxYmax(ShadowVolume)

Arguments:
	IN	OUT	pVertexBuffDesc		pVertexContext p[^o^o^
								KMVERTEXBUFFDESC \̂ւ̃|C^.
								炩 kmSetSystemConfiguration ɂ
								ĂKv܂B

	IN		pVertexContext		KMVERTEXCONTEXT \̂ւ̃|C^ݒ肵܂B

Result:
	KMSTATUS_SUCCESS			fBt@CẢe󂯂郌_Op[^
								o^

--*/

KMSTATUS KMAPI
kmSetModifierRenderState(
        IN	OUT	PKMVERTEXBUFFDESC   pVertexBuffDesc,
		IN		PKMVERTEXCONTEXT 	pVertexContext
	);


/*++
kmStartVertexStrip

proto type:
	KMSTATUS
	kmStartVertexStrip( 
			PKMVERTEXBUFFDESC pBufferDesc
		);

Description:
	_ЂɁA_f[^Xgbv̓o^Jn邱Ƃʒm܂B
	ȉ̊֐̌ĂяoŃVXeɓo^

		kmSetVertexRenderState
		kmSetModifierRenderState

	_Op[^A5̒_f[^Xĝꂩ֏݂܂B
	ޒ_f[^XǵA KMVERTEXCONTEXT
	ListTypeo猈肳܂B

ӁFŏ񂾃_Op[^̏ƁAɑkmSetVertexő
	  _p[^̌`̑gݍ킹Ȃꍇ͕̓ۏ؂܂B

	<{֐͍v邽InlineWJ}NƂĒ`܂B>

	}Ngpꍇɂ́Aȉ̂悤ɐݒ肵ĂB

		#define _KM_USE_VERTEX_MACRO_
		#include <kamui.h>
		#include <kamuix.h> 

Arguments:
	IN	pBufferDesc				PKMVERTEXBUFFDESC^́AVertex Buffer Descriptorւ̃|C^łB
								f[^o^钸_f[^Xg̏B

Result:
	KMSTATUS_SUCCESS			_Op[^ ݐ
	KMSTATUS_NOT_ENOUGH_MEMORY	_f[^Xg̗eʂȂ

--*/
#if !defined(_KM_USE_VERTEX_MACRO_)
KMSTATUS KMAPI
kmStartVertexStrip( 
		IN	PKMVERTEXBUFFDESC pBufferDesc
	);
#endif


/*++
kmEndVertexStrip

proto type:
	KMSTATUS KMAPI
	kmEndVertexStrip(
			IN  PKMVERTEXBUFFDESC   pVertexBuffDesc
		);
	
Description:
	
Arguments:
	IN	pVertexBuffDesc		

Result:
	KMSTATUS_SUCCESS		

--*/
KMSTATUS KMAPI
kmEndVertexStrip(
		IN  PKMVERTEXBUFFDESC   pVertexBuffDesc
	);
#endif
