//-----------------------------------------------------------------------------
// J[\
//-----------------------------------------------------------------------------

#ifndef _NWCURSOR_H_
#define _NWCURSOR_H_

//-----------------------------------------------------------------------------
class NWCURSOR: public NWGRAPHIC {
protected:
	PNWBITMAP		pBitmap;						// J[\prbg}bv
	int				bCreate;						// rbg}bv쐬
	int				nCursorNo;						// J[\ԍ
	PNWCSRINFO		pCsrInfo;						// ftHgJ[\Xg
	NWRECT			sClipRect;						// Nbv`
	
	NW_PERIPHERAL	*pPort;							// ytF
	int				nPortNo;						// |[gԍ
	
	NWCURSOR( void );
public:
	int				bCapture;						// Lv`[
	PNWCONTROL		pCapture;						// Lv`[Rg[
	
	int				nX;								// J[\XW
	int				nY;								// J[\YW
	int				nVX;							// J[\Xړ
	int				nVY;							// J[\Yړ
	int				nBX;							// ÕJ[\XW
	int				nBY;							// ÕJ[\YW
	int				nAX;							// AiOXl
	int				nAY;							// AiOYl
	int				nAL;							// AiOLl
	int				nAR;							// AiORl
	
	NWCURSOR( PNWCONTROL pRootControl );
	~NWCURSOR( void );
	
	void Release( void );
	void LoadCursor( PNWPVR pPvr );
	void SetBitmap( PNWBITMAP pBM );
	
	void SetClipRect( PNWRECT pNewR );
	NWRECT GetClipRect( void );
	void SetPortNo( int nNewNo );
	int GetPortNo( void );
	void Execute( void );
	void Draw( void );
	void SetCursorNo( int nNewNo );
	int GetCursorNo( void );
	
	void SetCapture( PNWCONTROL pControl );
};

//-----------------------------------------------------------------------------
#endif
