//-----------------------------------------------------------------------------
// t@Co[
//-----------------------------------------------------------------------------

#ifndef _NWFIBER_H_
#define _NWFIBER_H_

//-----------------------------------------------------------------------------

#define MAXLOG			(512)
#define MAXID			(16)
#define LOGID_VBLANKIN	(0)
#define LOGID_VBLANKOUT	(1)
#define LOGID_MAPLE		(2)
#define LOGID_EOR		(3)
#define LOGID_EOV		(4)
#define LOGID_EOD		(5)
#define LOGID_NINJA		(6)
#define LOGID_FIBER		(8)

typedef struct {
	char			nID;
	char			nFlag;
	char			nPos;
	char			nPad;
	unsigned long	nTime;
} LOG;

class NWFIBER: public NWFORM {
protected:
	PNWBUTTON	pL;
	PNWBUTTON	pR;
	
	int			nID0;
	int			nID1;
	int			nID2;
	int			nID3;
	
	int			nLogPoi;
	int			nLogSW;
	int			nTime;
	int			bFlip;
	int			nScale;
	int			bSysFlag;
	
	LOG Log0[MAXLOG];
	LOG Log1[MAXLOG];
	NWCOLOR BarColor[8][4];
	
	NWFIBER( void );
public:
	void LogRecord( int nID, int nPos, int nFlag, int nOffs );
	
	static void cbVBlankIn( void *pParam );
	static void cbVBlankOut( void *pParam );
	static void cbMaple( void );
	static void cbEOR( void *pParam );
	static void cbEOD( void *pParam );
	static void cbEOV( void );
	static void cbStart( void );
	static void cbRender( void );
	static void cbFiber( SYFBR pBefor, SYFBR pAfter );
	static void cbUser( int nID );
	NWFIBER( PNWCONTROL pRootControl );
	~NWFIBER( void );
	
	int MsgSysProc( NWCMD eCommand, PNWPARAM pParam );
	int OnPaint( PNWPARAM pParam );
	int OnClick( PNWPARAM pParam );
	int OnShow( PNWPARAM pParam );
	int OnHide( PNWPARAM pParam );
	int OnShortCut( PNWPARAM pParam );
};

//-----------------------------------------------------------------------------
#endif
