//-----------------------------------------------------------------------------
// Xg
//-----------------------------------------------------------------------------

#ifndef _NWLIST_H_
#define _NWLIST_H_

//-----------------------------------------------------------------------------
class NWLIST: public NWCLASS {
protected:
	int		nCapacity;
	
	void* Get( int nIndex );
	void Put( int nIndex, void *pPointer );
	void SetCapacity( int nNewCapacity );
	void Grow( void );
public:
	void**	Items;
	int		nCount;
	
	NWLIST( void );
	~NWLIST( void );
	
	void Clear( void );
	void Add( void *pPointer );
	void Delete( int nIndex );
	void Remove( void *pPointer );
	int IndexOf( void *pPointer );
	void Insert( int nIndex, void *pPointer );
	void Exchange( int nIndex0, int nIndex1 );
};

//-----------------------------------------------------------------------------
#endif
