//-----------------------------------------------------------------------------
// XN[o[
//-----------------------------------------------------------------------------

#ifndef _NWSCROLL_H_
#define _NWSCROLL_H_

class NWSCRBTN;
typedef NWSCRBTN *PNWSCRBTN;

//-----------------------------------------------------------------------------
class NWSCRBTN: public NWBUTTON {
	friend class NWSCROLL;
protected:
	NWSCRBTN( void );
public:
	NWSCRBTN( PNWCONTROL pRootControl );
	~NWSCRBTN( void );
	
	int MsgMouseUp( PNWMESSAGE pMessage );
};
//-----------------------------------------------------------------------------
class NWSCROLL: public NWGRAPHIC {
	friend class NWSCRBTN;
protected:
	PNWSCRBTN		pUpBtn;
	PNWSCRBTN		pDownBtn;
	NWRECT			sBarRect;
	
	NWSCROLL( void );
public:
	int				nMinNum;
	int				nMaxNum;
	int				nIncNum;
	int				nScrNum;
	int				nValue;
	
	NWSCROLL( PNWCONTROL pRootControl );
	~NWSCROLL( void );
	
	virtual void GoScroll( int nTag, int nVal );
	
	void Enable( void );
	void Disable( void );
	
	int MsgPaint( PNWMESSAGE pMessage );
	int MsgMouseDown( PNWMESSAGE pMessage );
	int MsgMouseUp( PNWMESSAGE pMessage );
	int MsgMouseMove( PNWMESSAGE pMessage );
	int MsgShortCut( PNWMESSAGE pMessage );
};
//-----------------------------------------------------------------------------
#endif
