//-----------------------------------------------------------------------------
// r[
//-----------------------------------------------------------------------------

#ifndef _NWVIEW_H_
#define _NWVIEW_H_

//-----------------------------------------------------------------------------

class NWVIEW: public NWGRAPHIC {
protected:
	long		*pBuffer;
	
	NWVIEW( void );
public:
	int			nW;
	int			nH;
	int			nViewX;
	int			nViewY;
	int			nViewW;
	int			nViewH;
	int			nCursorX;
	int			nCursorY;
	
	int			bScroll;
	int			nLine;
	
	NWVIEW( PNWCONTROL pRootControl );
	~NWVIEW( void );
	
	void vClear( void );
	void vCRLF( void );
	void vPrint( const char *pStr );
	void vPrintf( const char *pFmt, ... );
	void vScroll( int n );
	
	int MsgPaint( PNWMESSAGE pMessage );
};

//-----------------------------------------------------------------------------
#endif
