#ifndef	__MENU_H__
#define	__MENU_H__

typedef struct {
	int			Min;
	int			Max;
	int			Step;
	int			No;
} TMenuItemInt;

typedef struct {
	float		Min;
	float		Max;
	float		Step;
	float		No;
} TMenuItemFloat;

enum {
	MENU_TYPE_INT,
	MENU_TYPE_FLOAT,
	MENU_TYPE_MAX
};

typedef struct {
	char			*pStr;
	int				Type;				//MENU_TYPE_????
	void			*pMenuItem;			//TMenuItem????
} TMenuInfo;

void	ExecMenu( TMenuInfo *pMenuInfo, int MenuInfoMax );

#define	MENU_INFO_MAX		5
#define	MOTION_PATTERN_MAX	5

extern TMenuItemInt		MIMotionPattern[2];
extern TMenuItemFloat	MIMotionFrame[2];
extern TMenuItemFloat	MIMotionLinkRate;
extern TMenuInfo		MenuInfo[MENU_INFO_MAX];


#endif	/*__MENU_H__*/
