/*---------------------------------------------------------------------------
  Shinobi Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.
---------------------------------------------------------------------------*/

#include	<shinobi.h>
#include	"Nj.h"
#include	<nindows2.h>

NWINFORMATION Info;
int test( int argc, char *argv[] );
NWREGIST testcomd = { test, "test", "TEST Command." };
/*---------------------------------------------------------------------------
		
		initialize
---------------------------------------------------------------------------*/
Sint32	UserInit(void)
{
	Info.nSize  = sizeof( NWINFORMATION );
	Info.nFlags = NWD_USE_KEYBOARD
				| NWD_USE_MOUSE
				| NWD_USE_SERIAL
				| NWD_WINDOW_INFORMATION
				| NWD_WINDOW_PERFORMANCE
				| NWD_WINDOW_TEXTURE
				| NWD_WINDOW_CONSOLE;
	Info.nPadPort  = PDD_PORT_B0;
	Info.nWorkSize = nwGetWorkSize();
	Info.pWork     = syMalloc( Info.nWorkSize );
	if (njGetDisplayMode()&NJD_DSP_VGA)
		Info.nFontSize = NWD_FONT_NORMAL;
	else
		Info.nFontSize = NWD_FONT_LARGE;
	nwInitialize( &Info );
	
	nwRegisterCommand( &testcomd );
	
	nwDbPrintf( "Nindows debug print.\n" );
	nwDbPrintf( "Please connect keyboard.\n" );
	return USER_CONTINUE;
}
/*---------------------------------------------------------------------------
		I
		exit
---------------------------------------------------------------------------*/
Sint32	UserExit(void)
{
	nwFinalize();
	
	syFree( Info.pWork );
	
	return USER_CONTINUE;
}
/*---------------------------------------------------------------------------
		C
		main
---------------------------------------------------------------------------*/
Sint32	UserMain(void)
{
	if (Per->press&PDD_DGT_TA)
		nwExecuteCommand( "help" );
	
	return USER_CONTINUE;
}
/*-------------------------------------------------------------------------*/
int test( int argc, char *argv[] )
{
	Sint32 i;
	
	nwDbPrintf( "Testing... Argc = %d\n", argc );
	for( i=0; i<argc; i++ ) {
		nwDbPrintf( " Argv[%d] = %s\n", i, argv[i] );
	}
}
/*-------------------------------------------------------------------------*/
