/*---------------------------------------------------------------------------
  Shinobi2 Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.
---------------------------------------------------------------------------*/

#include	<shinobi.h>
#include	"Nj.h"
#include	"TexMain.h"

#define LOADTIME		(1)

Uint32 count1,count2,count;
Uint32 micro = 0;

Sint8 *buff;
Sint8 *buff2;

Sint8 *bmp;
Sint8 *buf;
/*---------------------------------------------------------------------------
		
		initialize
---------------------------------------------------------------------------*/
Sint32	UserInit(void)
{
	Int i;
	
#if LOADTIME
	count1 = syTmrGetCount();
#endif

	if(TexLoadMain() != USER_CONTINUE){
		return USER_EXIT;
	}

#if LOADTIME
	count2 = syTmrGetCount();
	count = syTmrDiffCount(count1,count2);
	micro = syTmrCountToMicro(count);
#endif

	bmp = syMalloc(640*480*3+54);
	buf = syMalloc(640*480*2);
	InitDrawTexture();

	return USER_CONTINUE;
}
/*---------------------------------------------------------------------------
		I
		exit
---------------------------------------------------------------------------*/
Sint32	UserExit(void)
{
	return USER_CONTINUE;
}
/*---------------------------------------------------------------------------
		C
		main
---------------------------------------------------------------------------*/
Sint32	UserMain(void)
{
	static Int cnt = 0;
	
	DrawTexture();


#if LOADTIME
	if(Per->press & PDD_DGT_TX){
		count1 = syTmrGetCount();

		njFrameBufferBmp(bmp,buf);
		
		count2 = syTmrGetCount();
		count = syTmrDiffCount(count1,count2);
		micro = syTmrCountToMicro(count);
	}
#endif
#if DEBUG	
#if LOADTIME
 	njPrint( NJM_LOCATION( 2,3 ), "TIME      : %d", micro);
#endif
 	njPrint( NJM_LOCATION( 2,2 ), "Tex Frame : %d", cnt++ );

 	njPrint( NJM_LOCATION( 2,8 ), "X      :TAKE A FRAME BITMAP");
 	njPrint( NJM_LOCATION( 2,9 ), "ADDRESS:0x%X",(Uint32)bmp);
#endif
	return USER_CONTINUE;
}
/*-------------------------------------------------------------------------*/
