/*---------------------------------------------------------------------------
  Shinobi Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.
---------------------------------------------------------------------------*/

#include	<shinobi.h>
#include	"Nj.h"

#define	OBJECT	 object_chie_Torus_Knot01_Torus_Knot01
#define TEXLIST texlist_chie_Torus_Knot01

extern	NJS_CNK_OBJECT	OBJECT[];
extern NJS_TEXLIST TEXLIST[];

static	Float	zzz = -400.f;
static	Float	xxx = 0.f;
static	Float	yyy = 0.f;

static	Sint32	xx = 0;
static	Sint32	yy = 0;
static	Sint32	zz = 0;

/*---------------------------------------------------------------------------
		
		initialize
---------------------------------------------------------------------------*/
Sint32	UserInit(void)
{
	if(nuLoadTexture( TEXLIST ) < 0){
		return USER_EXIT;
	}
	njSetTexture( TEXLIST );

	njCnkSetSimpleLight( 0.f, 0.f, -1.f );
	njCnkSetSimpleLightColor( 1.f, 0.9f, 0.1f );
	njCnkSetSimpleLightIntensity( 1.0f, 0.2f );

	return USER_CONTINUE;
}
/*---------------------------------------------------------------------------
		I
		exit
---------------------------------------------------------------------------*/
Sint32	UserExit(void)
{
	return USER_CONTINUE;
}
/*---------------------------------------------------------------------------
		C
		main
---------------------------------------------------------------------------*/
Sint32	UserMain(void)
{
	njPushMatrixEx();	

	njTranslate( NULL, xxx, yyy, zzz );
	njRotateXYZ( NULL, xx,yy,zz );

	njCnkSimpleDrawObject( OBJECT );

	njPopMatrixEx();

	if( Per->on & PDD_DGT_KL ) xxx -= 10;
	if( Per->on & PDD_DGT_KR ) xxx += 10;
	if( Per->on & PDD_DGT_KU ) yyy += 10;
	if( Per->on & PDD_DGT_KD ) yyy -= 10;
	if( Per->on & PDD_DGT_TL ) zzz -= 10;
	if( Per->on & PDD_DGT_TR ) zzz += 10;

	xx += 219;
	yy += 197;
	zz += 359;

	return USER_CONTINUE;
}
/*-------------------------------------------------------------------------*/
