/*
	Ninja Library
	
	COPYRIGHT ( C ) SEGA ENTERPRISES, LTD.
*/

#include "NuMotionMake.h"



/*
	_nu_motinfo_ptr_->int_f3_func_p				Float R̕⊮RA֐̃AhX
	_nu_motinfo_ptr_->int_a3_func_p				Angle R̕⊮RA֐̃AhX
	_nu_motinfo_ptr_->int_a1_func_p				Angle P̕⊮RA֐̃AhX
	_nu_motinfo_ptr_->int_sa3_func_p			Sangle R̕⊮RA֐̃AhX
*/

/*
	⊮{֐Q
	
	ʎdl:
	
	name:	_nuGetMotion<Type>
	
	func:	MDATA ̃Jgʒuf[^ǂݍ݁AJg[Vp[^ł̕⊮̃f[^ԂB
	
	in:		IȈ:
			<pData>												= f[^Ԃ̈ւ̃|C^
			
			Öق̈:
			_nu_motinfo_ptr_->cnt								= MDATA JE^
			_nu_motinfo_ptr_->key[_nu_motinfo_ptr_->cnt]		= <Type>Ɋ֘AL[ւ̃|C^
																  (̐ł́Akey Əj
			_nu_motinfo_ptr_->nbkeys[_nu_motinfo_ptr_->cnt]		= L[̌
			_nu_motinfo_ptr_->frame								= ⊮ʒũt[ԍ
			
	out:	߂l TRUE ̂ƂA<pData>	= ⊮̃f[^
	
	return:	TRUE	: key  NULL ł͂Ȃ̂ŁA̕⊮f[^ <pData> ɕԂB
			FALSE	: key  NULL ̂ŁAԂȂB<pData> ̓e͕ωȂB
	
	expl:	key  NULL ȊÔƂ͂̃L[̃f[^⊮āA
			 <pData> ̎wꂽꏊɕԂA߂l TRUE ƂȂB
			
			key  NULL ̂Ƃ́Aɖ߂l FALSE ƂB
			
			
			ǂ̏ꍇłA_nu_motinfo_ptr_->cnt KPB
*/


int _nuGetMotionFloat3( Float pos[3] )
{
	NUS_MKEY_F		*key;
	
	if ( ( key = (NUS_MKEY_F *)_nu_motinfo_ptr_->key[_nu_motinfo_ptr_->cnt] ) != NULL ) {
		(*_nu_motinfo_ptr_->int_f3_func_p)( key,
											_nu_motinfo_ptr_->nbkeys[_nu_motinfo_ptr_->cnt],
											_nu_motinfo_ptr_->frame, pos );
		
		_nu_motinfo_ptr_->cnt++;
		return	TRUE;
	}
	else {
		_nu_motinfo_ptr_->cnt++;
		return	FALSE;
	}
}

int _nuGetMotionFloat2( Float rang[2] )
{
	NUS_MKEY_F2		*key;
	
	if ( ( key = (NUS_MKEY_F2 *)_nu_motinfo_ptr_->key[_nu_motinfo_ptr_->cnt] ) != NULL ) {
		nuMotionIntLinearF2( key,
							_nu_motinfo_ptr_->nbkeys[_nu_motinfo_ptr_->cnt],
							_nu_motinfo_ptr_->frame, rang );
		
		_nu_motinfo_ptr_->cnt++;
		return	TRUE;
	}
	else {
		_nu_motinfo_ptr_->cnt++;
		return	FALSE;
	}
}

int _nuGetMotionAngle1( Angle *pAng )
{
	NUS_MKEY_A1		*key;
	
	if ( ( key = (NUS_MKEY_A1 *)_nu_motinfo_ptr_->key[_nu_motinfo_ptr_->cnt] ) != NULL ) {
		(*_nu_motinfo_ptr_->int_a1_func_p)( key,
											_nu_motinfo_ptr_->nbkeys[_nu_motinfo_ptr_->cnt],
											_nu_motinfo_ptr_->frame, pAng );
		
		_nu_motinfo_ptr_->cnt++;
		return	TRUE;
	}
	else {
		_nu_motinfo_ptr_->cnt++;
		return	FALSE;
	}
}

int _nuGetMotionSangle1( Sangle *pAng )
{
	NUS_MKEY_SA1		*key;
	
	if ( ( key = (NUS_MKEY_SA1 *)_nu_motinfo_ptr_->key[_nu_motinfo_ptr_->cnt] ) != NULL ) {
		nuMotionIntLinearSA1( key,
							_nu_motinfo_ptr_->nbkeys[_nu_motinfo_ptr_->cnt],
							_nu_motinfo_ptr_->frame, pAng );
		
		_nu_motinfo_ptr_->cnt++;
		return	TRUE;
	}
	else {
		_nu_motinfo_ptr_->cnt++;
		return	FALSE;
	}
}

int _nuGetMotionAngle3( Angle ang[3] )
{
	NUS_MKEY_A		*key;
	
	if ( ( key = (NUS_MKEY_A *)_nu_motinfo_ptr_->key[_nu_motinfo_ptr_->cnt] ) != NULL ) {
		(*_nu_motinfo_ptr_->int_a3_func_p)( key,
											_nu_motinfo_ptr_->nbkeys[_nu_motinfo_ptr_->cnt],
											_nu_motinfo_ptr_->frame, ang );
		
		_nu_motinfo_ptr_->cnt++;
		return	TRUE;
	}
	else {
		_nu_motinfo_ptr_->cnt++;
		return	FALSE;
	}
}

int _nuGetMotionSangle3( Sangle ang[3] )
{
	NUS_MKEY_SA		*key;
	
	if ( ( key = (NUS_MKEY_SA *)_nu_motinfo_ptr_->key[_nu_motinfo_ptr_->cnt] ) != NULL ) {
		(*_nu_motinfo_ptr_->int_sa3_func_p)( key,
											_nu_motinfo_ptr_->nbkeys[_nu_motinfo_ptr_->cnt],
											_nu_motinfo_ptr_->frame, ang );
		
		_nu_motinfo_ptr_->cnt++;
		return	TRUE;
	}
	else {
		_nu_motinfo_ptr_->cnt++;
		return	FALSE;
	}
}

int _nuGetMotionQuaternion( NJS_QUATERNION *qua )
{
	NUS_MKEY_QUAT	*key;
	
	if ( ( key = (NUS_MKEY_QUAT *)_nu_motinfo_ptr_->key[_nu_motinfo_ptr_->cnt] ) != NULL ) {
		nuMotionIntLinearQ( key,
							_nu_motinfo_ptr_->nbkeys[_nu_motinfo_ptr_->cnt],
							_nu_motinfo_ptr_->frame, (Float *)qua );
		
		_nu_motinfo_ptr_->cnt++;
		return	TRUE;
	}
	else {
		_nu_motinfo_ptr_->cnt++;
		return	FALSE;
	}
}

int _nuGetMotionEvent( Uint16* event )
{
	NUS_MKEY_UI16	*key;
	
	if ( ( key = (NUS_MKEY_UI16 *)_nu_motinfo_ptr_->key[_nu_motinfo_ptr_->cnt] ) != NULL ) {
		nuMotionIntEvent( key,
							_nu_motinfo_ptr_->nbkeys[_nu_motinfo_ptr_->cnt],
							_nu_motinfo_ptr_->frame, event );
		
		_nu_motinfo_ptr_->cnt++;
		return	TRUE;
	}
	else {
		_nu_motinfo_ptr_->cnt++;
		return	FALSE;
	}
}

