/*
	Ninja Library
	
	COPYRIGHT ( C ) SEGA ENTERPRISES, LTD.
*/

#include "NuMotionMake.h"



/*
	֐:	nuDrawMotionLink
	
	@  \:	[Vtf̕`֐
	
	  : object		= IuWFNg
			
			motion_link	= [VN\
			
			shape_link	= VF[vN\(NULL ł΁Aʏ̃[VN`ƂȂj
						  ݁AB
			rate		= ⊮Cg
			
			pDrawFunc	= `֐
	
	o  :	Ȃ
	߂l:	Ȃ
	T  v:
	  l:
*/
void nuDrawMotionLink( const NJS_CNK_OBJECT *object, const NUS_MOTION_LINK *motion_link,
						Float rate, Sint32 ( *pDrawFunc )( NJS_CNK_MODEL *cnkmodel ) )
{
	//	ꂩ珈eݒ
	nuStartMotionLink( motion_link, rate );
	
	
	//	`֐̃Zbg
	_nu_objmotinfo_ptr_->draw_func_p		= pDrawFunc;
	
	//	[V`Jn
	_nuPushPopMotionLink( object );
}

/****************************************************************/
/*	֐F_nuPushPopMotionLink								*/
/*	@  \F[Vtf̕`惁C					*/
/*	  ́FNJS_CNK_OBJECT *object	:IuWFNg				*/
/*	o  ́FȂ												*/
/*	߂lFȂ												*/
/*	T@vF													*/
/*	@lF													*/
/****************************************************************/
void _nuPushPopMotionLink( const NJS_CNK_OBJECT *cnkobj )
{
	NJS_CNK_OBJECT bcnkobj;

	do {
		njPushMatrixEx();
		
		nuMotionLinkTransformEx( cnkobj );

		/* ύX */
		if ( _nu_motion_event_flag_){
			bcnkobj = *cnkobj;
			nuChangeMotionObject( cnkobj );
		}
		
		if( _nu_motion_callback_ != NULL ) (*_nu_motion_callback_)( cnkobj );
		
		if ( ( cnkobj->model != NULL ) && ( !( cnkobj->evalflags & NJD_EVAL_HIDE ) ) ) {
			(*_nu_objmotinfo_ptr_->draw_func_p)( cnkobj->model );
		}
		
		/* ߂ */
		if ( _nu_motion_event_flag_){
			*(NJS_CNK_OBJECT *)cnkobj = bcnkobj;
		}
		
		if ( cnkobj->child != NULL ) {
			_nuPushPopMotionLink( ( const NJS_CNK_OBJECT* )cnkobj->child );
		}
		
		njPopMatrixEx();
		
		cnkobj = cnkobj->sibling;
		
	} while ( cnkobj != NULL );
}
