/*
	Ninja Library
	
	COPYRIGHT ( C ) SEGA ENTERPRISES, LTD.
*/

#include "NuMotionMake.h"

/*
	֐:	nuDrawMotion
	
	@  \:	[Vtf̕`֐
	
	  : object		= IuWFNg
			motion		= [V
			shape		= VF[v(NULL ł΁Aʏ̃[V`ƂȂj
			frame		= t[ԍ
			pDrawFunc	= `֐
	
	o  :	Ȃ
	߂l:	Ȃ
	T  v:
	  l:
*/
void nuDrawMotion( const NJS_CNK_OBJECT *object, const NUS_MOTION *motion, Float frame,
					Sint32 ( *pDrawFunc )( NJS_CNK_MODEL *cnkmodel ) )
{
	//	ꂩ珈eݒ
	nuStartMotionObj( motion, frame );
	
	//	`֐̃Zbg
	_nu_objmotinfo_ptr_->draw_func_p		= pDrawFunc;
	
	
	//	[V`Jn
	_nuPushPopMotion( object );
}

/****************************************************************/
/*	֐F_nuPushPopMotion									*/
/*	@  \F[Vtf̕`惁C					*/
/*	  ́FNJS_CNK_OBJECT *object	:IuWFNg				*/
/*	o  ́FȂ												*/
/*	߂lFȂ												*/
/*	T@vF													*/
/*	@lF													*/
/****************************************************************/
void _nuPushPopMotion( const NJS_CNK_OBJECT *cnkobj )
{
	NJS_CNK_OBJECT bcnkobj;
	
	do {
		njPushMatrixEx();
		
		nuMotionTransformEx( cnkobj );
		/* ύX */
		if ( _nu_motion_event_flag_){
			bcnkobj = *cnkobj;
			nuChangeMotionObject( cnkobj );
		}
		
		
		if( _nu_motion_callback_ != NULL ) (*_nu_motion_callback_)( cnkobj );

		if ( ( cnkobj->model != NULL ) && ( !( cnkobj->evalflags & NJD_EVAL_HIDE ) ) ) {
			(*_nu_objmotinfo_ptr_->draw_func_p)( cnkobj->model );
		}
		
		/* ߂ */
		if ( _nu_motion_event_flag_){
			*(NJS_CNK_OBJECT *)cnkobj = bcnkobj;
		}
		
		if ( cnkobj->child != NULL ) {
			_nuPushPopMotion( (const NJS_CNK_OBJECT *)cnkobj->child );
		}
		
		njPopMatrixEx();
		
		cnkobj = cnkobj->sibling;
		
	} while ( cnkobj != NULL );
}
