/*
	Ninja Library
	
	COPYRIGHT ( C ) SEGA ENTERPRISES, LTD.
*/

#include "NuMotionMake.h"


/*	֐̃vg^Cv錾	*/


/*
	֐:	nuCnkDrawShapeMotion
	
	@  \:	[Vtf̕`֐
	
	  : object		= IuWFNg
			motion		= [V
			shape		= VF[v(NULL ł΁Aʏ̃[V`ƂȂj
			frame		= t[ԍ
			pDrawFunc	= `֐
	
	o  :	Ȃ
	߂l:	Ȃ
	T  v:
	  l:
*/
void nuCnkDrawShapeMotion( NJS_CNK_OBJECT *object, const NUS_MOTION *motion, const NUS_MOTION *shape, Float frame, Float sframe,
							Sint32 ( *pDrawFunc )( NJS_CNK_MODEL *cnkmodel ) )
{
	//	ꂩ珈eݒ
	nuStartMotionObj( motion, frame );
	
	//	`֐̃Zbg
	_nu_objmotinfo_ptr_->draw_func_p		= pDrawFunc;
	
	
	if ( shape == NULL ) {
		//	[V`Jn
		_nuPushPopMotion( object );
	}
	else {
		//	VF[vL̏
		nuSetCurShapeInfoSlot( 0 );
		nuStartShapeEx( shape, sframe );
		
		//	VF[v`Jn
		_nuCnkPushPopShape( object );
	}
	
}

void _nuCnkPushPopShape( NJS_CNK_OBJECT *cnkobj )
{
	NJS_CNK_OBJECT bcnkobj;

	do {
		njPushMatrixEx();
		
		nuMotionTransformEx( cnkobj );
		/* ύX */
		if ( _nu_motion_event_flag_){
			bcnkobj = *cnkobj;
			nuChangeMotionObject( cnkobj );
		}
		
		if( _nu_motion_callback_ != NULL ) (*_nu_motion_callback_)( cnkobj );

		if ( !( cnkobj->evalflags & NJD_EVAL_SHAPE_SKIP ) ) {
			NJS_CNK_MODEL		*cnkmodel;
			if ( ( (cnkmodel = cnkobj->model) != NULL ) && ( !( cnkobj->evalflags & NJD_EVAL_HIDE ) ) ) {
				//Pm[h̒_VF[vAIWiVLISTɏ݂܂B
				if( _nu_shpinfo_ptr_->mdata->p[0] ) {
					nuCalcShapeVlist( cnkmodel );
				}
				(*_nu_objmotinfo_ptr_->draw_func_p)( cnkmodel );

			}
			//	ƂAf NULL łA܂AHIDE tOĂĂ
			//	VF[v MDATA |C^i߂KvLB
			nuSetNextShapeNodeEx();
		}
		else {
			NJS_CNK_MODEL		*cnkmodel;
			if ( ( (cnkmodel = cnkobj->model) != NULL ) && ( !( cnkobj->evalflags & NJD_EVAL_HIDE ) ) ) {
				(*_nu_objmotinfo_ptr_->draw_func_p)( cnkmodel );
			}
		}
		
			/* ߂ */
		if ( _nu_motion_event_flag_){
			*(NJS_CNK_OBJECT *)cnkobj = bcnkobj;
		}
		
		if ( cnkobj->child != NULL ) {
			_nuCnkPushPopShape( (NJS_CNK_OBJECT *)cnkobj->child );
		}
		
		njPopMatrixEx();
		
		cnkobj = cnkobj->sibling;
		
	} while ( cnkobj != NULL );
}
