/*
	Ninja Library
	
	COPYRIGHT (C) SEGA ENTERPRISES,LTD.
	
	Create 2000.03.01
*/
#include <Ninja.h>
#include <Njutil.h>

Sint8			*_nu_texture_buffer_st;
Uint32 			_nu_texture_buffer_max_size;
/****************************************************************/
/*  ֐FnuInitTextureBuffer						            */
/*  @  \FeNX`̃[Nobt@ݒ肷                */
/*    ́FSint8 *buf eNX`obt@̃AhX				*/
/*          Int	size	obt@̃TCY                        */
/*  o  ́FȂ                                                */
/*  ߂lFȂ                                                */
/*  T@vF                                                    */
/*  @lF                                                    */
/*                                                              */
/****************************************************************/
void nuInitTextureBuffer(Sint8 *buf,Int size)
{
	_nu_texture_buffer_st = buf;
	_nu_texture_buffer_max_size = (size/NJD_GD_SECT_SIZE)*NJD_GD_SECT_SIZE;

	
}

/****************************************************************/
/*  ֐FnuGetTextureBuffer						            */
/*  @  \FeNX`̃[Nobt@̏擾          */
/*    ́FȂ                                                */
/*  o  ́FSint8 **buf eNX`obt@̃AhX			*/
/*          Int	*size	obt@̃TCY                        */
/*  ߂lFȂ                                                */
/*  T@vF                                                    */
/*  @lF                                                    */
/*                                                              */
/****************************************************************/
void nuGetTextureBuffer(Sint8 **buf,Int *size)
{
	*size = _nu_texture_buffer_max_size;
	*buf = _nu_texture_buffer_st;

}
