/*
	Ninja Library
	
	COPYRIGHT (C) SEGA ENTERPRISES,LTD.

	Create 2000.03.01

*/
#include <Ninja.h>
#include <Njutil.h>

Sint32 nuLoadTextureLN(NJS_TEXLIST *texlist,Uint32 n);

/****************************************************************/
/*  ֐FnuLoadTextureSetG						            */
/*  @  \FO[oCfbNXtȂ烍[h        */
/*    ́FNJS_TEXLIST *texlist		                        */
/*  o  ́FȂ						                        */
/*  ߂lF@P@s@|P								*/
/*  T@vF                                                    */
/*  @lFeNX`̃O[oCfbNX𖳎		*/
/*			userglobalIndextĂ                       */
/*                                                              */
/****************************************************************/
Sint32 nuLoadTextureSetG(NJS_TEXLIST *texlist)
{
	Int i;
	Sint32 ret;
	
	for(i = 0;i < texlist->nbTexture;i++){
		texlist->textures[i].attr |= NJD_TEXATTR_GLOBALINDEX;
		texlist->textures[i].texaddr = _nj_user_globalIndex--;
		ret = nuLoadTextureLN(texlist,i);
		texlist->textures[i].attr &= ~NJD_TEXATTR_GLOBALINDEX;
		if(ret < 0){
			return -1;
		}
	}
}
