/*---------------------------------------------------------------------------
  Shinobi2 Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.
---------------------------------------------------------------------------*/

#include	<shinobi.h>
#include	"Nj.h"
#include	"mw_utils.h"
#include	"overlay1.h"
#include	"overlay2.h"

// The overlay number is determined by the order 
// the overlay is placed in the "Overlays" tab of
// the project window. The main application is
// defined as Overlay #1. Each overlay gets its
// own entry in the _overlay_section_address table.

#define OVERLAY1_NUMBER		1
#define OVERLAY2_NUMBER		2

// binary file name
#define OVERLAY1_FILENAME	"LOCALFUNCTION."
#define OVERLAY2_FILENAME	"GLOBALFUNCTION."

Sint32	gCount	= 0;
Sint32	gVar	= 0; /*global variable*/

/*---------------------------------------------------------------------------
		
		initialize
---------------------------------------------------------------------------*/
Sint32	UserInit(void)
{
	return USER_CONTINUE;
}
/*---------------------------------------------------------------------------
		I
		exit
---------------------------------------------------------------------------*/
Sint32	UserExit(void)
{
	return USER_CONTINUE;
}
/*---------------------------------------------------------------------------
		C
		main
---------------------------------------------------------------------------*/
Sint32	UserMain(void)
{
	Sint32				result;
	void*				pAddr;

	gCount++;

	pAddr = MWGetGroupAddress(OVERLAY1_NUMBER);
	if(MWLoadOverlay(OVERLAY1_FILENAME,pAddr)){
		result = func_ol1(gCount);
		}
	pAddr = MWGetGroupAddress(OVERLAY2_NUMBER);
	if(MWLoadOverlay(OVERLAY2_FILENAME,pAddr)){
		result = func_ol2(gCount);
		}
	njPrintC(NJM_LOCATION(4,  2), "Overlay Tutorial");
	return USER_CONTINUE;
}
/*-------------------------------------------------------------------------*/
