#ifndef _CTXEXP_H
#define _CTXEXP_H

#include "basapi.h"

#define ERR_BUF_TOO_SMALL          ( ERRORID ) 110 
/*@doc ASRADDED ASRERR 
*/
/*@type ERR_BUF_TOO_SMALL | (110) output buffer too small.*/

/*@doc ASRADDED
*/
/* @func This function exports a context to a data buffer. */
/* @rdesc Error code. */
/* @comm The context data buffer actual length is always returned, even if NULL
  is passed via the parameter pCtx. */
ERRORID CasrExportContext(
  HCONT hCont,        /* @parm <t HCONT> | hCont | Context instance handle [INPUT]. */
  PCONT pCont,        /* @parm <t PCONT> | pCont | Context data buffer [OUTPUT]. */
  PDWORD pdwLength  /* @parm <t PDWORD> | pdwLength | Length in bytes of context data buffer [INPUT/OUTPUT]. */
);

#endif
