/*
 *  Middleware Library
 *  Copyright (c) 1998 SEGA
 *  
 *		Dual Speech
 *
 *  Module  : Library Header File
 *  File    : DLSD_MW.H
 *  Create  : 1999-05-12
 *  Modify  : 1999-09-21
 *  Note    :
 */

#ifndef	_DLSD_MW_H_
#define	_DLSD_MW_H_

/***************************************************************************
 *      Process MACRO
 ***************************************************************************/
#define	MWD_DLSD_CALC_WORK(n)		(56 * n)

#define	MWD_DLSD_EXTRA_SIZE			(640)

#define	MWD_DLSD_SAMPLE_NUM			(1)

#define	MWD_DLSD_MEMORY_LIMIT		(20)
#ifdef	__cplusplus
extern	"C"	{
#endif	/*	__cplusplus		*/

/***************************************************************************
 *		Variable Declaration
 ***************************************************************************/

extern	DCAIF	mwg_dcaif_dlsd;

/***************************************************************************
 *      Function Declaration
 ***************************************************************************/

/*	Initialize Dual Speech Library		*/
#define	mwPlyInitDlsd(mode)			mwPlaInit(mode, &mwg_dcaif_dlsd)

/*	Finish using Dual Speech Library	*/
#define	mwPlyFinishDlsd()			mwPlaFinish(&mwg_dcaif_dlsd)

/*	Create MWPLY handle for Dual Speech	*/
#define	mwPlyCreateDlsd(cprm)		mwPlaCreate(cprm, &mwg_dcaif_dlsd)

#ifdef	__cplusplus
}
#endif	/*	__cplusplus		*/
#endif	/*	_DLSD_MW_H_	*/
