/*---------------------------------------------------------------------------
  Kamui Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.
---------------------------------------------------------------------------*/

#ifndef _KM_H_
#define	_KM_H_

#ifdef __cplusplus
extern "C" {
#endif

#define _STRICT_UNION_
#include	<Kamui2.h>
#include	<KmUtil.h>
#include	<KmuDebug.h>

/*-------------------------------------------------------------------------*/

#define DEBUG (TRUE)
#define NOWLOADING (TRUE)

#define USER_CONTINUE		(0)
#define USER_EXIT			(-1)

#define TEXTURE_MEMORY_SIZE		(4*1024*1024)
#define VERTEXBUFFER_SIZE		(4*1024*1024)

extern Sint32 UserInit(void);
extern Sint32 UserExit(void);
extern Sint32 UserMain(void);

extern KMVERTEXBUFFDESC		VertexBufferDesc;
extern KMSYSTEMCONFIGSTRUCT	SystemConfig;
extern PKMSURFACEDESC		pSurfaceArray[2];
extern KMSURFACEDESC		PrimarySurfaceDesc;
extern KMSURFACEDESC		BackSurfaceDesc;

extern PKMDWORD				pTextureWork;
extern PKMDWORD				pVertexBufferWork;

extern const PDS_PERIPHERAL	*Per;
extern Bool					bExitFlag;
extern Bool					bExitEnable;

extern void DisplayNowLoading( void );
extern void InitBackGround( Uint32 c0, Uint32 c1, Uint32 c2 );
/*-------------------------------------------------------------------------*/
#ifdef __cplusplus
}
#endif

#endif
