//-----------------------------------------------------------------------------
// tH[
//-----------------------------------------------------------------------------

#ifndef _NWFORM_H_
#define _NWFORM_H_

class NWSYSBTN;
typedef NWSYSBTN *PNWSYSBTN;

//-----------------------------------------------------------------------------
class NWSYSBTN: public NWBUTTON {
	friend class NWFORM;
protected:
	NWSYSBTN( void );
public:
	NWSYSBTN( PNWCONTROL pRootControl );
	~NWSYSBTN( void );
	
	int MsgMouseUp( PNWMESSAGE pMessage );
};
//-----------------------------------------------------------------------------
class NWFORM: public NWGRAPHIC {
	friend class NWSYSBTN;
protected:
	char			xCaption[256];
	int				nFormStyle;
	int				bActive;
	int				bResize;
	int				nResize;
	NWFORMSTATUS	eStatus;
	PNWCONTROL		pActiveCtrl;
	NWRECT			sFormRect;
	
	NWFORM( void );
	void Release( void );
public:
	PNWPOPUPMENU	pPopup;
	PNWCAPTION		pCaption;
	PNWSYSBTN		pMax;
	PNWSYSBTN		pMin;
	PNWSYSBTN		pSys;
	
	NWFORM( PNWCONTROL pRootControl );
	~NWFORM( void );
	
	int IsActive( void );
	void SetCaption( char* pStr );
	char* GetCaption( void );
	void SetFormStyle( int nNewStyle );
	
	void SetActiveControl( PNWCONTROL pCtrl );
	PNWCONTROL GetActiveControl( void );
	NWFORMSTATUS GetStatus( void );
	
	int MsgProc( PNWMESSAGE pMessage );
	int MsgPaint( PNWMESSAGE pMessage );
	int MsgMouseDown( PNWMESSAGE pMessage );
	int MsgMouseUp( PNWMESSAGE pMessage );
	int MsgMouseMove( PNWMESSAGE pMessage );
	
	virtual int MsgComdProc( NWCMD eCommand, PNWPARAM pParam );
	virtual int MsgSysProc( NWCMD eCommand, PNWPARAM pParam );
	
	virtual int OnIdle( PNWPARAM pParam )				{ return 0; };
	virtual int OnPaint( PNWPARAM pParam )				{ return 0; };
	virtual int OnClick( PNWPARAM pParam )				{ return 0; };
	virtual int OnMouseDown( PNWPARAM pParam )			{ return 0; };
	virtual int OnMouseMove( PNWPARAM pParam )			{ return 0; };
	virtual int OnMouseUp( PNWPARAM pParam )			{ return 0; };
	virtual int OnKeyDown( PNWPARAM pParam )			{ return 0; };
	virtual int OnKeyUp( PNWPARAM pParam )				{ return 0; };
	virtual int OnShow( PNWPARAM pParam )				{ return 0; };
	virtual int OnHide( PNWPARAM pParam )				{ return 0; };
	virtual int OnDialog( PNWPARAM pParam )				{ return 0; };
	virtual int OnResize( PNWPARAM pParam )				{ return 0; };
	virtual int OnShortCut( PNWPARAM pParam )			{ return 0; };
};
//-----------------------------------------------------------------------------
#endif
