//-----------------------------------------------------------------------------
// IMAGELIST
//-----------------------------------------------------------------------------

#ifndef _NWIMAGELIST_H_
#define _NWIMAGELIST_H_

//-----------------------------------------------------------------------------

class NWIMAGELIST: public NWCLASS {
protected:
	int			nCapacity;
	PNWIMAGETIP	pImage;
	
	void Grow( void );
	void SetCapacity( int nNewCapacity );
public:
	int			nCount;
	
	NWIMAGELIST( void );
	~NWIMAGELIST( void );
	
	PNWIMAGETIP Get( int nIndex );
	void Put( int nIndex, PNWIMAGETIP pImageTip );
	
	int AddImage( PNWBITMAP pSrc, PNWRECT pR );
	int AddImageList( PNWIMAGELIST pImageList );
	void Clear( void );
};

//-----------------------------------------------------------------------------
#endif
