//-----------------------------------------------------------------------------
// ytF
//-----------------------------------------------------------------------------

#ifndef _NWPERI_H_
#define _NWPERI_H_

//-----------------------------------------------------------------------------

class NWPERI: public NWFORM {
protected:
	PNWGRAPHIC		pPanel;
	PNWBUTTON		pL;
	PNWBUTTON		pR;
	NWCOLOR			sHalfColor;
	int				nPortNo;
	
	PNWBUTTON		pVib;
	PNWBUTTON		pLcd;
	
	NWPERI( void );
	void DrawCsr( int nX, int nY, int nBits );
	void DrawAnalog( int nX, int nY, int x, int y, PNWCOLOR pCol );
public:
	NWPERI( PNWCONTROL pRootControl );
	~NWPERI( void );
	
	int MsgSysProc( NWCMD eCommand, PNWPARAM pParam );
	int OnClick( PNWPARAM pParam );
	int OnPaint( PNWPARAM pParam );
	int OnShortCut( PNWPARAM pParam );
};

//-----------------------------------------------------------------------------
#endif
