//-----------------------------------------------------------------------------
// [U[
//-----------------------------------------------------------------------------

#include <NWHEAP.H>
#include <Nindows2SDK.H>
#include "nwUser.H"

/*-----------------------------------------------------------------------------
rbg}bvǂݍłACRƂă{^ɓ\t@ƁÂ܂
C[WƂĕ\@܂B
-----------------------------------------------------------------------------*/

NWUSER *pUser;
//-----------------------------------------------------------------------------
// R[obNɌĂ΂܂B
static void nwCallback( NWCALLBACKCONTEXT eCtx, void* pParam )
{
	switch (eCtx) {
	// tHg؂ւOɌĂ΂܂BŃtH[jĂB
	case NW_CALLBACK_FONT_CHANGING:
		nwUnregistForm( pUser );
		NWDELETE( pUser );
		break;
	// tHg؂ւɌĂ΂܂BĂуtH[\z܂B
	case NW_CALLBACK_FONT_CHANGED:
		pUser = new NWUSER( nwGetDesktop() );
		nwRegistForm( pUser );
		pUser->Show();
		break;
	}
}
//-----------------------------------------------------------------------------
void nwInitializeUser( void )
{
	pUser = new NWUSER( nwGetDesktop() );
	nwRegistForm( pUser );
	pUser->Show();
	
	// R[obNo^܂
	pGlobal->RegistCallback( NW_CALLBACK_FONT_CHANGING, nwCallback );
	pGlobal->RegistCallback( NW_CALLBACK_FONT_CHANGED , nwCallback );
}
void nwFinalizeUser( void )
{
	// R[obN܂
	pGlobal->UnregistCallback( NW_CALLBACK_FONT_CHANGING, nwCallback );
	pGlobal->UnregistCallback( NW_CALLBACK_FONT_CHANGED , nwCallback );
	
	nwUnregistForm( pUser );
	NWDELETE( pUser );
}
//-----------------------------------------------------------------------------
NWUSER::NWUSER( void )
{
}
//-----------------------------------------------------------------------------
NWUSER::NWUSER( PNWCONTROL pRootControl ) :
	NWFORM( pRootControl )
{
	NWRECT R;
	SetCaption( "USER FORM" );
	SetFormStyle( NW_FORM_NORMAL );
	
	R.nX = 300;
	R.nY = 200;
	R.nW = NWSCALX(200);		// tHgTCYɑΉXP[O
	R.nH = NWSCALY(150);		// tHgTCYɑΉXP[O
	SetRectClip( &R );
	
	// rbg}bv쐬AGDPVRt@Cǂݍ݂܂B
	pBitmap = new NWBITMAP;
	pBitmap->LoadFromFile( "icon.pvr" );
	
	// plƃ{^쐬܂Bꂼew肵č쐬Ă܂B
	// pllŔzuA{^͂̃pl̏ɍlŔzu܂B
	// {^ɃACRݒ肵܂B
	pPanel  = new NWGRAPHIC( this );
	R.nH = NWSCALY(40);
	pPanel->SetAlign( alTop );
	pPanel->SetRect( &R );
	
	R.nH  = NWSCALX(40);
	R.nW  = NWSCALY(40);
	for( int i=0; i<4; i++ ) {
		pBtn[i] = new NWBUTTON( pPanel );
		pBtn[i]->SetAlign( alLeft );
		pBtn[i]->SetRect( &R );
		pBtn[i]->SetBitmap( pBitmap );
		pBtn[i]->nTag = 0x100 + i;
		
		NWCOLOR sCol = 0xfeffffff;
		pBtn[i]->SetFontColor( &sCol );
		
		NWRECT R2;
		R2.nX = (i%2)*32;
		R2.nY = (i/2)*32;
		R2.nW = 32;
		R2.nH = 32;
		pBtn[i]->SetBitmapRect( &R2 );
	}
	
	// o^郁j[̃ev[g(C++̂Ƃ͈Ⴄ)łBV[gJbgL[
	// ͓o^Ă@\܂BKw邱Ƃ\łB
	NWMENUTEMPLATE sMenuItem = {
		TRUE,
		TRUE,
		-1,
		0x100,
		'U',
		"&User",
		NW_CMD_ONCLICK,
		NULL,
	};
	
	// j[o^B֐ŃCX^X쐬ꂻ̃|C^ԂB
	// nTagthis邱ƂɂăCxgnhOĂ܂B
	sMenuItem.nTag = (int)this;
	pMenuItem = nwAddUserMenu( &sMenuItem );
}
//-----------------------------------------------------------------------------
NWUSER::~NWUSER( void )
{
	// j[j܂BCX^X֐Ŕj܂B
	nwDelUserMenu( pMenuItem );
	
	// plƃ{^j܂B
	NWDELETE( pBtn[0] );
	NWDELETE( pBtn[1] );
	NWDELETE( pBtn[2] );
	NWDELETE( pBtn[3] );
	NWDELETE( pPanel  );
	NWDELETE( pBitmap );
}
//-----------------------------------------------------------------------------
int NWUSER::OnShow( PNWPARAM pParam )
{
	// Rg[\ꂽƂɔCxgBRg[tH[
	// ǂ`FbNĂeLq܂Bł̓j[ACe
	// `FbN}[NIɂĂ܂B
	if (pParam->pSender==this)
		pMenuItem->SetIconIndex(26);
	return 0;
}
//-----------------------------------------------------------------------------
int NWUSER::OnHide( PNWPARAM pParam )
{
	// Rg[BꂽƂɔCxgBRg[tH[
	// ǂ`FbNĂeLq܂Bł̓j[ACe
	// `FbN}[NItɂĂ܂B
	if (pParam->pSender==this)
		pMenuItem->SetIconIndex(-1);
	return 0;
}
//-----------------------------------------------------------------------------
int NWUSER::OnClick( PNWPARAM pParam )
{
	// j[NbNꂽƂ̃CxgłB
	if (pParam->pSender==pMenuItem) {
		if (IsVisible()==FALSE) {
			// \ꍇ́A\ANeBuɂđOʂɏo܂B
			Show();
			nwSetActiveForm( this );
			nwBringToFront( this );
		} else {
			// \ꍇ́A\ɂ܂B
			Hide();
		}
	}
	return 0;
}
//-----------------------------------------------------------------------------
int NWUSER::OnPaint( PNWPARAM pParam )
{
	// tH[`悷CxgłB
	if (pParam->pSender==this) {
		PNWFONT pFont = pGlobal->GetCurrentFont();
		pFont->SetColor( &sFontColor );
		
		// C[WƘg\Ă܂B
		NWRECT dstR,srcR;
		NWCOLOR Col[2];
		
		srcR.nX =  0;
		srcR.nY =  0;
		srcR.nW = 64;
		srcR.nH = 64;
		dstR.nX =  8;
		dstR.nY = 60;
		dstR.nW = 64;
		dstR.nH = 64;
		
		Col[0] = 0xfeffffff;
		BitBlt( &dstR, &srcR, pBitmap, &Col[0] );
		
		nwInflateRect( &dstR, -1 );
		Col[0] = 0xffffffff;
		Col[1] = 0xff000000;
		DrawBox( &dstR, &Col[0] );
	}
	return 0;
}
//-----------------------------------------------------------------------------
