/*---------------------------------------------------------------------------
  Shinobi2 Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.
---------------------------------------------------------------------------*/

#include	<shinobi.h>
#include	"Nj.h"
#include	"TexMain.h"

#define LOADTIME		(1)

Uint32 count1,count2,count;
Uint32 micro = 0;

/*---------------------------------------------------------------------------
		
		initialize
---------------------------------------------------------------------------*/
Sint32	UserInit(void)
{
#if LOADTIME
	count1 = syTmrGetCount();
#endif

	if(TexLoadMain() != USER_CONTINUE){
		return USER_EXIT;
	}

#if LOADTIME
	count2 = syTmrGetCount();
	count = syTmrDiffCount(count1,count2);
	micro = syTmrCountToMicro(count);
#endif

	InitDrawTexture();
	return USER_CONTINUE;
}
/*---------------------------------------------------------------------------
		I
		exit
---------------------------------------------------------------------------*/
Sint32	UserExit(void)
{
	return USER_CONTINUE;
}
/*---------------------------------------------------------------------------
		C
		main
---------------------------------------------------------------------------*/
Sint32	UserMain(void)
{
	static Int cnt = 0;
	
	DrawTexture();
	
#if DEBUG	
#if LOADTIME
 	njPrint( NJM_LOCATION( 2,3 ), "TIME      : %d", micro);
#endif
 	njPrint( NJM_LOCATION( 2,2 ), "Tex Mem   : %d", cnt++ );
	return USER_CONTINUE;
#endif	
}
/*-------------------------------------------------------------------------*/
