/*
	Ninja Library
	
	COPYRIGHT ( C ) SEGA ENTERPRISES, LTD.
*/

#include "NuMotionMake.h"


/*
	֐:	 nuDrawShapeLink
	
	@  \:	[Vtf̕`֐
	
	  : object		= IuWFNg
			
			motion_link	= [VN\
			
			shape_link	= VF[vN\(NULL ł΁Aʏ̃[VN`ƂȂj
						  ݁AB
			rate		= ⊮Cg
			
			pDrawFunc	= `֐
	
	o  :	Ȃ
	߂l:	Ȃ
	T  v:
	  l:
*/
void nuCnkDrawShapeLink( NJS_CNK_OBJECT *object, const NUS_MOTION_LINK *motion_link, const NUS_MOTION_LINK *shape_link,
						  Float rate, Sint32 ( *pDrawFunc )( NJS_CNK_MODEL *cnkmodel ) )
{
	//	ꂩ珈eݒ
	nuStartMotionLink( motion_link, rate );
	
	
	//	`֐̃Zbg
	_nu_objmotinfo_ptr_->draw_func_p		= pDrawFunc;
	
	if ( shape_link == NULL ) {
		//	[V`Jn
		_nuPushPopMotionLink( object );
	}
	else {
		//	VF[vNL̏
		nuStartShapeLink( shape_link, rate );
		
		//	VF[vN`Jn
		_nuCnkPushPopShapeLink( object );
	}
}

void _nuCnkPushPopShapeLink( NJS_CNK_OBJECT *cnkobj )
{
	NJS_CNK_OBJECT bcnkobj;

	do {
		njPushMatrixEx();
		
		nuMotionLinkTransformEx( cnkobj );
		
		/* ύX */
		if ( _nu_motion_event_flag_){
			bcnkobj = *cnkobj;
			nuChangeMotionObject( cnkobj );
		}

		if ( !( cnkobj->evalflags & NJD_EVAL_SHAPE_SKIP ) ) {
			NJS_CNK_MODEL		*cnkmodel;
			if ( ( (cnkmodel = cnkobj->model) != NULL ) && ( !( cnkobj->evalflags & NJD_EVAL_HIDE ) ) ) {
				//Pm[h̒_VF[vAIWiVLISTɏ݂܂B
				if( _nu_shpinfo_ptr_->mdata->p[0] ) {
					nuCalcShapeLinkVlist( cnkmodel );
				}
				(*_nu_objmotinfo_ptr_->draw_func_p)( cnkmodel );

			}
			//	ƂAf NULL łA܂AHIDE tOĂĂ
			//	VF[v MDATA |C^i߂KvLB
			nuSetNextShapeLinkNode();
		}
		else {
			NJS_CNK_MODEL		*cnkmodel;
			if ( ( (cnkmodel = cnkobj->model) != NULL ) && ( !( cnkobj->evalflags & NJD_EVAL_HIDE ) ) ) {
				(*_nu_objmotinfo_ptr_->draw_func_p)( cnkmodel );
			}
		}
		
		/* ߂ */
		if ( _nu_motion_event_flag_){
			*(NJS_CNK_OBJECT *)cnkobj = bcnkobj;
		}

		if ( cnkobj->child != NULL ) {
			_nuCnkPushPopShapeLink( (NJS_CNK_OBJECT *)cnkobj->child );
		}
		
		njPopMatrixEx();
		
		cnkobj = cnkobj->sibling;
		
	} while ( cnkobj != NULL );
}
