/*
	Ninja Library
	
	COPYRIGHT (C) SEGA ENTERPRISES,LTD.

	Create 2000.03.01

*/
#include <Ninja.h>
#include <Njutil.h>

/****************************************************************/
/*  ֐FnuLoadPaletteFile								    */
/*  @  \Fpbg̃f[^[h					    */
/*    ́Fconst char *filename								*/
/*			NJS_TEXPALETTE *pl									*/
/*  o  ́FȂ                                                */
/*  ߂lF Ps |P                                    */
/*  T@vF                                                    */
/*  @lF                                                    */
/****************************************************************/
Sint32 nuLoadPaletteFile(const char *filename,NJS_TEXPALETTE *pl)
{
	Sint8 *texbuf;
	Int texbuf_size;
	
	nuGetTextureBuffer(&texbuf,&texbuf_size);
	
	if(nuTexFreadAll(filename,texbuf,texbuf_size) < 0){
		return -1;
	}
	
	return njLoadPaletteData(texbuf,pl);

}