/*---------------------------------------------------------------------------
  Shinobi Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.
---------------------------------------------------------------------------*/

#include	<shinobi.h>
#include	<Ninja.h>
#include	"Nj.h"
#include "fntDisp.h"

SMS_FNT_MODE_OBJ gSmsFntModeObj, *gSmsFntMode;

/*---------------------------------------------------------------------------
		
		initialize
---------------------------------------------------------------------------*/
Sint32	UserInit(void)
{
	gSmsFntMode = &gSmsFntModeObj;
	initFntMode( gSmsFntMode );
	initFontTexture();

	return USER_CONTINUE;
}
/*---------------------------------------------------------------------------
		I
		exit
---------------------------------------------------------------------------*/
Sint32	UserExit(void)
{
	return USER_CONTINUE;
}
/*---------------------------------------------------------------------------
		C
		main
---------------------------------------------------------------------------*/
Sint32	UserMain(void)
{
	static cnt = 0;
	static Angle ty;
	NJS_POLYGON_VTX vtx[4];
	
	vtx[0].x   = -1.f;
	vtx[0].y   = +1.f;
	vtx[0].z   =  0.f;
	vtx[0].col = 0xffff0000;
	vtx[1].x   = -1.f;
	vtx[1].y   = -1.f;
	vtx[1].z   =  0.f;
	vtx[1].col = 0xff00ff00;
	vtx[2].x   = +1.f;
	vtx[2].y   = +1.f;
	vtx[2].z   =  0.f;
	vtx[2].col = 0xff0000ff;
	vtx[3].x   = +1.f;
	vtx[3].y   = -1.f;
	vtx[3].z   =  0.f;
	vtx[3].col = 0xffffffff;
	
	njPushMatrixEx();
	njTranslate( NULL, 0.f, 0.f, -5.f );
	njRotateXYZ( NULL, 0,ty,0 );

	chooseFont( gSmsFntMode );
	displayFont( gSmsFntMode );

	njPopMatrixEx();
	ty += 180;
	
 	njPrint( NJM_LOCATION( 2,2 ), "SHINOBI2 SAMPLE %d", cnt++ );
	return USER_CONTINUE;
}
/*-------------------------------------------------------------------------*/
