/*---------------------------------------------------------------------------
  Shinobi Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.
---------------------------------------------------------------------------*/

#include	<shinobi.h>
#include	"Nj.h"


/*-------------------------------------------------------------------------*/
#define OBJECT  object_chie_Torus_Knot01_Torus_Knot01

extern NJS_CNK_OBJECT OBJECT[];

static Float zzz = -400.f;
static Float xxx = 0.f;
static Float yyy = 0.f;

static Sint32 xx = 0;
static Sint32 yy = 0;
static Sint32 zz = 0;

/*-------------------------------------------------------------------------*/
void PrintPeripheralInfo(Sint32 x, Sint32 y, Uint32 port);

/*-------------------------------------------------------------------------*/
Uint32 gFrameCount;

/*---------------------------------------------------------------------------
		
		initialize
---------------------------------------------------------------------------*/
Sint32	UserInit(void)
{
	gFrameCount = 0;
	njSetBackColor(0x00004080, 0x00004080, 0x004080);

	bup_init();
	return USER_CONTINUE;
}

/*---------------------------------------------------------------------------
		I
		exit
---------------------------------------------------------------------------*/
Sint32	UserExit(void)
{
	bup_exit();

	return USER_CONTINUE;
}

/*---------------------------------------------------------------------------
		C
		main
---------------------------------------------------------------------------*/
Sint32	UserMain(void)
{
	bup_main();

	njPrintC(NJM_LOCATION(4,  2), "BACKUP SAMPLE #2");
	njPrintH(NJM_LOCATION(30,  2), gFrameCount, 8);

	/* Draw Torus */
	njPushMatrixEx();

	njTranslate(NULL, xxx, yyy, zzz);
	njRotateXYZ(NULL, xx, yy, zz);

	njCnkWireDrawObject(OBJECT);

	njPopMatrixEx();

	xx += 219;
	yy += 197;
	zz += 359;

	gFrameCount++;

	return USER_CONTINUE;
}

/*-------------------------------------------------------------------------*/
